<?php

/**
 * This is the model base class for the table "acordadas".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Acordadas".
 *
 * Columns in table "acordadas" available as properties of the model,
 * followed by relations of table "acordadas" available as properties of the model.
 *
 * @property string $Numero
 * @property string $Fecha
 * @property string $TemaAcuerdo
 * @property string $Descripcion
 * @property string $Acuerdo
 * @property string $Firmantes
 * @property integer $Publicar
 *
 * @property ImgAcordadas[] $imgAcordadases
 */
abstract class BaseAcordadas extends GxActiveRecord {
	public $from_date;
	public $to_date;

	// Todos los SELECT obtienen solo acordadas públicas
	public function defaultScope() {
		return array(
			'condition'=>"Publicar=1",
		);
	}
	
	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'acordadas';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Acordada|Acordadas', $n);
	}

	public static function representingColumn() {
		return 'Numero';
	}

	public function rules() {
		return array(
			array('Numero, Fecha, Acuerdo, Firmantes, Publicar', 'required'),
			array('Publicar', 'numerical', 'integerOnly'=>true),
			array('Numero', 'length', 'max'=>10),
			array('TemaAcuerdo, Firmantes', 'length', 'max'=>200),
			array('Descripcion', 'safe'),
			array('TemaAcuerdo, Descripcion', 'default', 'setOnEmpty' => true, 'value' => null),
			array('Fecha', 'date', 'format'=>'d-M-yyyy'),
			array('from_date,to_date', 'date', 'format'=>'dd-MM-yyyy', 'allowEmpty'=>false),
			array('from_date,to_date', 'ChkDate'),
			array('Numero, Fecha, TemaAcuerdo, Descripcion, Acuerdo, Firmantes, Publicar, from_date, to_date', 'safe', 'on'=>'search'),
		);
	}

	public function ChkDate($attribute,$params) {
//Yii::log( "this->$attribute=".$this->$attribute, 'warning', 'application');
		$test_arr  = explode('-', $this->$attribute);
		if(count($test_arr)!=3) {
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
			return false;
		}
		
		$day	 = $test_arr[2];
		$month = $test_arr[1];
		$year	 = $test_arr[0];

		if(!(is_numeric($day)&&is_numeric($month)&&is_numeric($year))) {
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
			return false;
		}
		
		if(checkdate($month, $day, $year)) {
//Yii::log( "checkdate=TRUE", 'warning', 'application');
			if($this->$attribute > "1899-12-31 00:00:00" && $this->$attribute < date("Y-m-d H:i:s")){
				return true;
			}else{
				$this->addError($attribute, $attribute." debe estar entre 1900-01-01 y ".date("Y-m-d"));
			}
		}else{
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
		}
	}

	public function relations() {
		return array(
			'imgAcordadases' => array(self::HAS_MANY, 'ImgAcordadas', 'Numero'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'from_date' 	=> Yii::t('app', 'Desde'),
			'to_date'			=> Yii::t('app', 'Hasta'),
			'Numero' => Yii::t('app', 'Numero'),
			'Fecha' => Yii::t('app', 'Fecha'),
			'TemaAcuerdo' => Yii::t('app', 'Tema Acuerdo'),
			'Descripcion' => Yii::t('app', 'Descripcion'),
			'Acuerdo' => Yii::t('app', 'Acuerdo'),
			'Firmantes' => Yii::t('app', 'Firmantes'),
			'Publicar' => Yii::t('app', 'Publicar'),
			'imgAcordadases' => null,
		);
	}

	public function search() {
		$from_date_MySQL = '';
		$to_date_MySQL 	 = '';

		$criteria = new CDbCriteria;

		$criteria->compare('Numero', $this->Numero, true);
		$criteria->compare('Fecha', $this->Fecha, true);
		$criteria->compare('TemaAcuerdo', $this->TemaAcuerdo, true);
		$criteria->compare('Descripcion', $this->Descripcion, true);
		$criteria->compare('Acuerdo', $this->Acuerdo, true);
		$criteria->compare('Firmantes', $this->Firmantes, true);
		$criteria->compare('Publicar', $this->Publicar);

		$this->from_date = trim( $this->from_date );
		$this->to_date 	 = trim( $this->to_date );
		if(!empty($this->from_date) && empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'd-M-yyyy'));
				$criteria->addCondition( "Fecha >= '$from_date_MySQL'" );
			}
		elseif(empty($this->from_date) && !empty($this->to_date))
			{
				$to_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'd-M-yyyy'));
				$criteria->addCondition( "Fecha <= '$to_date_MySQL'" );
			}
		elseif(!empty($this->from_date) && !empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'd-M-yyyy'));
				$to_date_MySQL 	 = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'd-M-yyyy'));
				$criteria->addCondition( "Fecha BETWEEN '$from_date_MySQL' AND '$to_date_MySQL'");
			}		
Yii::log( "*** this->from_date:".$this->from_date, 'warning', 'application');
Yii::log( "from_date_MySQL:".$from_date_MySQL, 'warning', 'application');		
		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}