<?php

/**
 * This is the model base class for the table "resoluciones".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Resoluciones".
 *
 * Columns in table "resoluciones" available as properties of the model,
 * followed by relations of table "resoluciones" available as properties of the model.
 *
 * @property string $numerores
 * @property string $fecha
 * @property string $temares
 * @property string $descripcion
 * @property string $resolucion
 * @property string $firmantes
 * @property integer $publicar
 *
 * @property ImgResoluciones[] $imgResoluciones
 */
abstract class BaseResoluciones extends GxActiveRecord {
	public $from_date;
	public $to_date;

	// Todos los SELECT obtienen solo resoluciones públicas
	public function defaultScope() {
		return array(
			'condition'=>"publicar=1",
		);
	}
	
	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'resoluciones';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Resolución|Resoluciones', $n);
	}

	public static function representingColumn() {
		return 'numerores';
	}

	public function rules() {
		return array(
			array('numerores, fecha, temares, resolucion, firmantes, publicar', 'required'),
			array('publicar', 'numerical', 'integerOnly'=>true),
			array('numerores', 'length', 'max'=>10),
			array('temares, firmantes', 'length', 'max'=>200),
			array('descripcion', 'safe'),
			array('descripcion', 'default', 'setOnEmpty' => true, 'value' => null),
			array('Fecha', 'date', 'format'=>'d-M-yyyy'),
			array('from_date,to_date', 'date', 'format'=>'dd-MM-yyyy', 'allowEmpty'=>false),
			array('numerores, fecha, temares, descripcion, resolucion, firmantes, publicar, from_date, to_date', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'imgResoluciones' => array(self::HAS_MANY, 'ImgResoluciones', 'Numero'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'from_date' 	=> Yii::t('app', 'Desde'),
			'to_date'			=> Yii::t('app', 'Hasta'),
			'numerores' => Yii::t('app', 'Número'),
			'fecha' => Yii::t('app', 'Fecha'),
			'temares' => Yii::t('app', 'Tema'),
			'descripcion' => Yii::t('app', 'Descripción'),
			'resolucion' => Yii::t('app', 'Resolución'),
			'firmantes' => Yii::t('app', 'Firmantes'),
			'publicar' => Yii::t('app', 'Publicar'),
			'imgResoluciones' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('numerores', $this->numerores, true);
		$criteria->compare('fecha', $this->fecha, true);
		$criteria->compare('temares', $this->temares, true);
		$criteria->compare('descripcion', $this->descripcion, true);
		$criteria->compare('resolucion', $this->resolucion, true);
		$criteria->compare('firmantes', $this->firmantes, true);
		$criteria->compare('publicar', $this->publicar);

		$this->from_date = trim( $this->from_date );
		$this->to_date 	 = trim( $this->to_date );
		if(!empty($this->from_date) && empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'd-M-yyyy'));
				$criteria->addCondition( "Fecha >= '$from_date_MySQL'" );
			}
		elseif(empty($this->from_date) && !empty($this->to_date))
			{
				$to_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'd-M-yyyy'));
				$criteria->addCondition( "Fecha <= '$to_date_MySQL'" );
			}
		elseif(!empty($this->from_date) && !empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'd-M-yyyy'));
				$to_date_MySQL 	 = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'd-M-yyyy'));
				$criteria->addCondition( "Fecha BETWEEN '$from_date_MySQL' AND '$to_date_MySQL'");
			}		
		
		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}