<?php

class DeudorAlimentarioController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			);
}

public function accessRules() {
	return array(
			array('allow',
				'actions'=>array('index','view','admin'),
				'users'=>array('*'),
				),
			array('deny', 
				'actions'=>array('minicreate','create','update','delete'),
				'users'=>array('*'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'DeudorAlimentario'),
		));
	}

	public function actionCreate() {
		$model = new DeudorAlimentario;


		if (isset($_POST['DeudorAlimentario'])) {
			$model->setAttributes($_POST['DeudorAlimentario']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdDeudorAlimentario));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'DeudorAlimentario');


		if (isset($_POST['DeudorAlimentario'])) {
			$model->setAttributes($_POST['DeudorAlimentario']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdDeudorAlimentario));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'DeudorAlimentario')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('DeudorAlimentario');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new DeudorAlimentario('search');
		$model->unsetAttributes();

		if (isset($_GET['DeudorAlimentario']))
			$model->setAttributes($_GET['DeudorAlimentario']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

}