<?php

class EstadDeudorAlimentarioController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			);
}

public function accessRules() {
	return array(
			array('allow',
				//'actions'=>array('index','view'),
				'actions'=>array('index','view','admin'),
				'users'=>array('*'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create','update'),
				'users'=>array('@'),
				),
			array('allow', 
				//'actions'=>array('admin','delete'),
				'actions'=>array('delete'),
				'users'=>array('informatica', 'LSerrano', 'KLobo'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'EstadDeudorAlimentario'),
		));
	}

	public function actionCreate() {
		$model = new EstadDeudorAlimentario;


		if (isset($_POST['EstadDeudorAlimentario'])) {
			$model->setAttributes($_POST['EstadDeudorAlimentario']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdDeudorAlimentario));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'EstadDeudorAlimentario');


		if (isset($_POST['EstadDeudorAlimentario'])) {
			$model->setAttributes($_POST['EstadDeudorAlimentario']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdDeudorAlimentario));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'EstadDeudorAlimentario')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('EstadDeudorAlimentario');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new EstadDeudorAlimentario('search');
		$model->unsetAttributes();

		if (isset($_GET['EstadDeudorAlimentario']))
			$model->setAttributes($_GET['EstadDeudorAlimentario']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

}