<?php

class JuzgadoController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			);
}

public function accessRules() {
	return array(
			array('allow',
				'actions'=>array('index','view','admin'),
				'users'=>array('*'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create','update'),
				'users'=>array('@'),
				),
			array('allow', 
				'actions'=>array('delete'),
				'users'=>array('informatica', 'LSerrano', 'KLobo'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'Juzgado'),
		));
	}

	public function actionCreate() {
		$model = new Juzgado;


		if (isset($_POST['Juzgado'])) {
			$model->setAttributes($_POST['Juzgado']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdJuzgado));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'Juzgado');


		if (isset($_POST['Juzgado'])) {
			$model->setAttributes($_POST['Juzgado']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdJuzgado));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'Juzgado')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Juzgado');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Juzgado('search');
		$model->unsetAttributes();

		if (isset($_GET['Juzgado']))
			$model->setAttributes($_GET['Juzgado']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

}