<?php

/**
 * This is the model base class for the table "regjuiciosuniv.deudor_alimentario".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DeudorAlimentario".
 *
 * Columns in table "regjuiciosuniv.deudor_alimentario" available as properties of the model,
 * followed by relations of table "regjuiciosuniv.deudor_alimentario" available as properties of the model.
 *
 * @property string $IdDeudorAlimentario
 * @property string $IdJuzgado
 * @property string $NroCausante
 * @property string $AnioCausante
 * @property string $Apellido
 * @property string $Nombre
 * @property string $TipoDoc
 * @property integer $Documento
 * @property string $NroExpediente
 * @property string $FechaInscripcion
 *
 * @property Juzgado $idJuzgado
 */
abstract class BaseDeudorAlimentario extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'regjuiciosuniv.deudor_alimentario';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Deudor Alimentario|Deudores Alimentarios', $n);
	}

	public static function representingColumn() {
		return 'Apellido';
	}

	public function rules() {
		return array(
			array('IdJuzgado, NroCausante, AnioCausante, Apellido, Nombre, TipoDoc, Documento, NroExpediente, FechaInscripcion', 'required'),
			array('Documento', 'numerical', 'integerOnly'=>true),
			array('IdJuzgado, NroCausante, AnioCausante', 'length', 'max'=>10),
			array('NroCausante, AnioCausante', 'numerical', 'integerOnly'=>true),
			array('Apellido, Nombre', 'length', 'max'=>45),
			array('TipoDoc', 'length', 'max'=>9),
			array('NroExpediente', 'length', 'max'=>15),
			array('IdDeudorAlimentario, IdJuzgado, NroCausante, AnioCausante, Apellido, Nombre, TipoDoc, Documento, NroExpediente, FechaInscripcion', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'idJuzgado' => array(self::BELONGS_TO, 'Juzgado', 'IdJuzgado'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdDeudorAlimentario' => Yii::t('app', 'Id Deudor Alimentario'),
			'IdJuzgado' => null,
			'NroCausante' => Yii::t('app', 'Nro Causante'),
			'AnioCausante' => Yii::t('app', 'Año Causante'),
			'Apellido' => Yii::t('app', 'Apellido'),
			'Nombre' => Yii::t('app', 'Nombre'),
			'TipoDoc' => Yii::t('app', 'Tipo Doc'),
			'Documento' => Yii::t('app', 'Documento'),
			'NroExpediente' => Yii::t('app', 'Nro Expediente'),
			'FechaInscripcion' => Yii::t('app', 'Fecha Inscripcion'),
			'idJuzgado' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdDeudorAlimentario', $this->IdDeudorAlimentario, true);
		$criteria->compare('IdJuzgado', $this->IdJuzgado);
		$criteria->compare('NroCausante', $this->NroCausante, true);
		$criteria->compare('AnioCausante', $this->AnioCausante, true);
		$criteria->compare('Apellido', $this->Apellido, true);
		$criteria->compare('Nombre', $this->Nombre, true);
		$criteria->compare('TipoDoc', $this->TipoDoc, true);
		$criteria->compare('Documento', $this->Documento);
		$criteria->compare('NroExpediente', $this->NroExpediente, true);
		$criteria->compare('FechaInscripcion', $this->FechaInscripcion, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}