<?php

/**
 * This is the model base class for the table "quiebra".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Quiebra".
 *
 * Columns in table "quiebra" available as properties of the model,
 * followed by relations of table "quiebra" available as properties of the model.
 *
 * @property string $IdQuiebra
 * @property string $NroQuiebra
 * @property string $AnioQuiebra
 * @property string $FechaInicio
 * @property string $FechaRegistro
 * @property string $NroExpediente
 * @property string $Caratula
 * @property string $Profesional
 * @property string $IdJuzgado
 * @property string $IdEstado
 * @property string $Nota
 *
 * @property EstadoQuiebra $idEstado
 * @property Juzgado $idJuzgado
 */
abstract class BaseQuiebra extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'quiebra';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Quiebra|Quiebras', $n);
	}

	public static function representingColumn() {
		return 'Caratula';
	}

	public function rules() {
		return array(
			array('NroQuiebra, AnioQuiebra, FechaInicio, FechaRegistro, Caratula, Profesional, IdJuzgado, IdEstado', 'required'),
			array('NroQuiebra, AnioQuiebra, IdJuzgado, IdEstado', 'length', 'max'=>10),
			array('NroExpediente', 'length', 'max'=>15),
			array('Caratula', 'length', 'max'=>500),
			array('Profesional', 'length', 'max'=>45),
			array('Nota', 'length', 'max'=>800),
			array('NroExpediente, Nota', 'default', 'setOnEmpty' => true, 'value' => null),
			array('IdQuiebra, NroQuiebra, AnioQuiebra, FechaInicio, FechaRegistro, NroExpediente, Caratula, Profesional, IdJuzgado, IdEstado, Nota', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'idEstado' => array(self::BELONGS_TO, 'EstadoQuiebra', 'IdEstado'),
			'idJuzgado' => array(self::BELONGS_TO, 'Juzgado', 'IdJuzgado'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdQuiebra' => Yii::t('app', 'Id Quiebra'),
			'NroQuiebra' => Yii::t('app', 'Nro Quiebra'),
			'AnioQuiebra' => Yii::t('app', 'Año Quiebra'),
			'FechaInicio' => Yii::t('app', 'Fecha Inicio'),
			'FechaRegistro' => Yii::t('app', 'Fecha Registro'),
			'NroExpediente' => Yii::t('app', 'Nro Expediente'),
			'Caratula' => Yii::t('app', 'Carátula'),
			'Profesional' => Yii::t('app', 'Profesional'),
			'IdJuzgado' => null,
			'IdEstado' => null,
			'Nota' => Yii::t('app', 'Nota'),
			'idEstado' => null,
			'idJuzgado' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdQuiebra', $this->IdQuiebra, true);
		$criteria->compare('NroQuiebra', $this->NroQuiebra, true);
		$criteria->compare('AnioQuiebra', $this->AnioQuiebra, true);
		$criteria->compare('FechaInicio', $this->FechaInicio, true);
		$criteria->compare('FechaRegistro', $this->FechaRegistro, true);
		$criteria->compare('NroExpediente', $this->NroExpediente, true);
		$criteria->compare('Caratula', $this->Caratula, true);
		$criteria->compare('Profesional', $this->Profesional, true);
		$criteria->compare('IdJuzgado', $this->IdJuzgado);
		$criteria->compare('IdEstado', $this->IdEstado);
		$criteria->compare('Nota', $this->Nota, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}