<?php

/**
 * This is the model base class for the table "regjuiciosuniv.sucesorio".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Sucesorio".
 *
 * Columns in table "regjuiciosuniv.sucesorio" available as properties of the model,
 * followed by relations of table "regjuiciosuniv.sucesorio" available as properties of the model.
 *
 * @property string $IdCausante
 * @property string $IdJuzgado
 * @property string $NroCausante
 * @property string $AnioCausante
 * @property string $Apellido
 * @property string $Nombre
 * @property string $TipoDoc
 * @property integer $Documento
 * @property string $Sexo
 * @property string $FechaFallecimiento
 * @property string $EstadoCivil
 * @property string $Domicilio
 * @property string $Profesional
 * @property string $TipoProfesional
 * @property string $NroExpediente
 * @property string $FechaInicioDemanda
 * @property string $FechaRegistroDemanda
 *
 * @property Juzgado $idJuzgado
 */
abstract class BaseSucesorio extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'regjuiciosuniv.sucesorio';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Sucesorio|Sucesorios', $n);
	}

	public static function representingColumn() {
		return 'Apellido';
	}

	public function rules() {
		return array(
			array('IdJuzgado, NroCausante, AnioCausante, Apellido, Nombre, TipoDoc, Documento, Sexo, FechaFallecimiento, EstadoCivil, Domicilio, Profesional, TipoProfesional, NroExpediente, FechaInicioDemanda, FechaRegistroDemanda', 'required'),
			array('Documento', 'numerical', 'integerOnly'=>true),
			array('IdJuzgado, NroCausante, AnioCausante', 'length', 'max'=>10),
			array('NroCausante, AnioCausante', 'numerical', 'integerOnly'=>true),
			array('Apellido, Nombre, Domicilio, Profesional', 'length', 'max'=>45),
			array('TipoDoc', 'length', 'max'=>9),
			array('Sexo', 'length', 'max'=>9),
			array('EstadoCivil', 'length', 'max'=>11),
			array('TipoProfesional', 'length', 'max'=>12),
			array('NroExpediente', 'length', 'max'=>15),
			array('IdCausante, IdJuzgado, NroCausante, AnioCausante, Apellido, Nombre, TipoDoc, Documento, Sexo, FechaFallecimiento, EstadoCivil, Domicilio, Profesional, TipoProfesional, NroExpediente, FechaInicioDemanda, FechaRegistroDemanda', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'idJuzgado' => array(self::BELONGS_TO, 'Juzgado', 'IdJuzgado'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdCausante' => Yii::t('app', 'Id Causante'),
			'IdJuzgado' => null,
			'NroCausante' => Yii::t('app', 'Nro Causante'),
			'AnioCausante' => Yii::t('app', 'Año Causante'),
			'Apellido' => Yii::t('app', 'Apellido'),
			'Nombre' => Yii::t('app', 'Nombre'),
			'TipoDoc' => Yii::t('app', 'Tipo Doc'),
			'Documento' => Yii::t('app', 'Documento'),
			'Sexo' => Yii::t('app', 'Sexo'),
			'FechaFallecimiento' => Yii::t('app', 'Fecha Fallecimiento'),
			'EstadoCivil' => Yii::t('app', 'Estado Civil'),
			'Domicilio' => Yii::t('app', 'Domicilio'),
			'Profesional' => Yii::t('app', 'Profesional'),
			'TipoProfesional' => Yii::t('app', 'Tipo Prof.'),
			'NroExpediente' => Yii::t('app', 'Nro Exped'),
			'FechaInicioDemanda' => Yii::t('app', 'Fecha Inic Demanda'),
			'FechaRegistroDemanda' => Yii::t('app', 'Fecha Reg Demanda'),
			'idJuzgado' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdCausante', $this->IdCausante, true);
		$criteria->compare('IdJuzgado', $this->IdJuzgado);
		$criteria->compare('NroCausante', $this->NroCausante, true);
		$criteria->compare('AnioCausante', $this->AnioCausante, true);
		$criteria->compare('Apellido', $this->Apellido, true);
		$criteria->compare('Nombre', $this->Nombre, true);
		$criteria->compare('TipoDoc', $this->TipoDoc, true);
		$criteria->compare('Documento', $this->Documento);
		$criteria->compare('Sexo', $this->Sexo, true);
		$criteria->compare('FechaFallecimiento', $this->FechaFallecimiento, true);
		$criteria->compare('EstadoCivil', $this->EstadoCivil, true);
		$criteria->compare('Domicilio', $this->Domicilio, true);
		$criteria->compare('Profesional', $this->Profesional, true);
		$criteria->compare('TipoProfesional', $this->TipoProfesional, true);
		$criteria->compare('NroExpediente', $this->NroExpediente, true);
		$criteria->compare('FechaInicioDemanda', $this->FechaInicioDemanda, true);
		$criteria->compare('FechaRegistroDemanda', $this->FechaRegistroDemanda, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}