<?php

class DeudorAlimentarioController extends GxController {

	public function filters() {
		return array(
				'accessControl', 
				);
	}
	
	public function accessRules() {
		return array(
				array('allow',
					'actions'=>array('index','view','admin'),	
					'users'=>array('*'),
					),
				array('allow', 
					'actions'=>array('minicreate', 'create','update','checkDuplicateUser'),
					'users'=>array('@'),
					),
				array('allow', 
					'actions'=>array('delete'),
					'users'=>array('informatica','A.M.Carrizo','K.Lobo','M.Ibanez','J.Cortez','B.Figueroa','M.Angelina','V.Cappiello','C.Walther'),
					),
				array('deny', 
					'users'=>array('*'),
					),
				);
	}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'DeudorAlimentario'),
		));
	}

	public function actionCreate() {
		$model = new DeudorAlimentario;


		if (isset($_POST['DeudorAlimentario'])) {
			$model->setAttributes($_POST['DeudorAlimentario']);

			try
			{
				// Try to create
				if ($model->save()) {
					if (Yii::app()->getRequest()->getIsAjaxRequest())
						Yii::app()->end();
					else
						$this->redirect(array('view', 'id' => $model->IdDeudorAlimentario));
				}
			}
			catch (CDbException $e)
			{
				if($e->getCode()==23000) {
					throw new CHttpException('Número y Año de causante duplicado. ('.
																		$model->NroCausante.'/'.$model->AnioCausante.') <BR>'.
																		'<a href="'.Yii::app()->request->urlReferrer.'">Retornar a la página anterior.</a>'
																	);
				} else {
					throw new CHttpException('Codigo error: '.$e->getCode().'<BR>Mensaje de error: '.$e->getMessage() );
				}
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'DeudorAlimentario');


		if (isset($_POST['DeudorAlimentario'])) {
			$model->setAttributes($_POST['DeudorAlimentario']);

			try
			{
				// Try to update
				if ($model->save()) {
					$this->redirect(array('view', 'id' => $model->IdDeudorAlimentario));
				}
			}
			catch (CDbException $e)
			{
				if($e->getCode()==23000) {
					throw new CHttpException('Número y Año de causante duplicado. ('.
																		$model->NroCausante.'/'.$model->AnioCausante.') <BR>'.
																		'<a href="'.Yii::app()->request->urlReferrer.'">Retornar a la página anterior.</a>'
																	);
				} else {
					throw new CHttpException('Codigo error: '.$e->getCode().'<BR>Mensaje de error: '.$e->getMessage() );
				}
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'DeudorAlimentario')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('DeudorAlimentario');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new DeudorAlimentario('search');
		$model->unsetAttributes();

		if (isset($_GET['DeudorAlimentario']))
			$model->setAttributes($_GET['DeudorAlimentario']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

	public function actioncheckDuplicateUser() {
		$q = 'SELECT COUNT(*) FROM deudor_alimentario WHERE NroCausante='.$_GET['NroCausante'].' And AnioCausante='.$_GET['AnioCausante'];
		$cmd = Yii::app()->db->createCommand($q);
		$num = $cmd->queryScalar();		
		
		if( $num != 0 ) {
			echo( 'true' );
		} else {
			echo( 'false' );
		}
		Yii::app()->end();
	}
}