<?php

class EstadSucesorioController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			);
}

public function accessRules() {
	return array(
			array('allow',
				'actions'=>array('index','view', 'admin'),
				'users'=>array('*'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create','update'),
				'users'=>array('@'),
				),
			array('allow', 
				'actions'=>array('delete'),
				'users'=>array('informatica','A.M.Carrizo','K.Lobo','M.Ibanez','V.Cappiello','C.Walther'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'EstadSucesorio'),
		));
	}

	public function actionCreate() {
		$model = new EstadSucesorio;


		if (isset($_POST['EstadSucesorio'])) {
			$model->setAttributes($_POST['EstadSucesorio']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdCausante));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'EstadSucesorio');


		if (isset($_POST['EstadSucesorio'])) {
			$model->setAttributes($_POST['EstadSucesorio']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdCausante));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'EstadSucesorio')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('EstadSucesorio');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new EstadSucesorio('search');
		$model->unsetAttributes();

		if (isset($_GET['EstadSucesorio'])) {
			$model->setAttributes($_GET['EstadSucesorio']);
		}
		$this->render('admin', array(
			'model' => $model,
		));
	}

}