<?php

class EstadoQuiebraController extends GxController {

	public function filters() {
		return array(
				'accessControl', 
				);
	}
	
	public function accessRules() {
		return array(
				array('allow',
					'actions'=>array('index','view','admin'),
					'users'=>array('*'),
					),
				array('allow', 
					'actions'=>array('minicreate', 'create','update'),
					'users'=>array('@'),
					),
				array('allow', 
					'actions'=>array('delete'),
					'users'=>array('informatica','A.M.Carrizo','K.Lobo','M.Ibanez','J.Cortez','B.Figueroa','M.Angelina','V.Cappiello','C.Walther'),
					),
				array('deny', 
					'users'=>array('*'),
					),
				);
	}
	
	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'EstadoQuiebra'),
		));
	}

	public function actionCreate() {
		$model = new EstadoQuiebra;


		if (isset($_POST['EstadoQuiebra'])) {
			$model->setAttributes($_POST['EstadoQuiebra']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdEstado));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'EstadoQuiebra');


		if (isset($_POST['EstadoQuiebra'])) {
			$model->setAttributes($_POST['EstadoQuiebra']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdEstado));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

/*	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'EstadoQuiebra')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}*/

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {

			try{
					$this->loadModel($id, 'EstadoQuiebra')->delete();
					/*if(!isset($_GET['ajax']))
							// Normal (without ajax)
							Yii::app()->user->setFlash('success','Normal - Juzgado eliminado con éxito.');
					else
							//for ajax
							echo "<div class='text-success'>Ajax - Juzgado eliminado con éxito.</div>";*/
			}catch(CDbException $e){
					$cod_err = $e->errorInfo[1];
Yii::log( "Codigo err:".$cod_err." - ".$e->getMessage(), 'warning', 'application');
					if($cod_err==1217) {
						$estado = $this->loadModel($id, 'EstadoQuiebra')->Estado;
						if(!isset($_GET['ajax']))
								// Normal (without ajax)
								Yii::app()->user->setFlash('error','No se puede eliminar el estado ('.$estado.') porque tiene registros asociados.');
						else
								//for ajax
								echo "<div class='text-error'>No se puede eliminar el estado (".$estado.") porque tiene registros asociados.</div>";
					} else {
						if(!isset($_GET['ajax']))
								// Normal (without ajax)
								Yii::app()->user->setFlash('error','Codigo error: '.$cod_err.'<BR>Mensaje de error: '.$e->getMessage());
						else
								//for ajax
								echo "<div class='text-error'>Codigo error: ".$cod_err."<BR>Mensaje de error: ".$e->getMessage()."</div>";
					}
			}
 
			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
					$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));

		} else
				throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('EstadoQuiebra');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new EstadoQuiebra('search');
		$model->unsetAttributes();

		if (isset($_GET['EstadoQuiebra']))
			$model->setAttributes($_GET['EstadoQuiebra']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

}