<?php

class JuzgadoController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			);
}

public function accessRules() {
	return array(
			array('allow',
				'actions'=>array('index','view','admin'),
				'users'=>array('*'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create','update'),
				'users'=>array('@'),
				),
			array('allow', 
				'actions'=>array('delete'),
				'users'=>array('informatica','A.M.Carrizo','K.Lobo','M.Ibanez','J.Cortez','B.Figueroa','M.Angelina','V.Cappiello','C.Walther'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'Juzgado'),
		));
	}

	public function actionCreate() {
		$model = new Juzgado;


		if (isset($_POST['Juzgado'])) {
			$model->setAttributes($_POST['Juzgado']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdJuzgado));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'Juzgado');


		if (isset($_POST['Juzgado'])) {
			$model->setAttributes($_POST['Juzgado']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdJuzgado));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {

			try{
					$this->loadModel($id, 'Juzgado')->delete();
					/*if(!isset($_GET['ajax']))
							// Normal (without ajax)
							Yii::app()->user->setFlash('success','Normal - Juzgado eliminado con éxito.');
					else
							//for ajax
							echo "<div class='text-success'>Ajax - Juzgado eliminado con éxito.</div>";*/
			}catch(CDbException $e){
					$cod_err = $e->errorInfo[1];
//Yii::log( "Codigo err:".$cod_err." - ".$e->getMessage(), 'warning', 'application');
					if($cod_err==1217) {
						$juzgado = $this->loadModel($id, 'Juzgado')->Nombre;
						if(!isset($_GET['ajax']))
								// Normal (without ajax)
								Yii::app()->user->setFlash('error','No se puede eliminar el juzgado ('.$juzgado.') porque tiene registros asociados.');
						else
								//for ajax
								echo "<div class='text-error'>No se puede eliminar el juzgado (".$juzgado.") porque tiene registros asociados.</div>";
					} else {
						if(!isset($_GET['ajax']))
								// Normal (without ajax)
								Yii::app()->user->setFlash('error','Codigo error: '.$cod_err.'<BR>Mensaje de error: '.$e->getMessage());
						else
								//for ajax
								echo "<div class='text-error'>Codigo error: ".$cod_err."<BR>Mensaje de error: ".$e->getMessage()."</div>";
					}
			}
 
			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
					$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));

		} else
				throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Juzgado');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Juzgado('search');
		$model->unsetAttributes();

		if (isset($_GET['Juzgado']))
			$model->setAttributes($_GET['Juzgado']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

}