<?php

class QuiebraController extends GxController {

	public function filters() {
		return array(
				'accessControl', 
				);
	}
	
	public function accessRules() {
		return array(
				array('allow',
					'actions'=>array('index','view','admin'),
					'users'=>array('*'),
					),
				array('allow', 
					'actions'=>array('minicreate', 'create','update','checkDuplicateQuiebra'),
					'users'=>array('@'),
					),
				array('allow', 
					'actions'=>array('delete'),
					'users'=>array('informatica','A.M.Carrizo','K.Lobo','M.Ibanez','J.Cortez','B.Figueroa','M.Angelina','V.Cappiello','C.Walther'),
					),
				array('deny', 
					'users'=>array('*'),
					),
				);
	}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'Quiebra'),
		));
	}

	public function actionCreate() {
		$model = new Quiebra;


		if (isset($_POST['Quiebra'])) {
			$model->setAttributes($_POST['Quiebra']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdQuiebra));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'Quiebra');


		if (isset($_POST['Quiebra'])) {
			$model->setAttributes($_POST['Quiebra']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdQuiebra));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'Quiebra')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Quiebra');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Quiebra('search');
		$model->unsetAttributes();

		if (isset($_GET['Quiebra']))
			$model->setAttributes($_GET['Quiebra']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

	public function actioncheckDuplicateQuiebra() {
		$q = 'SELECT COUNT(*) FROM quiebra WHERE NroQuiebra='.$_GET['NroQuiebra'].' And AnioQuiebra='.$_GET['AnioQuiebra'];
		$cmd = Yii::app()->db->createCommand($q);
		$num = $cmd->queryScalar();		
		
		if( $num != 0 ) {
			echo( 'true' );
		} else {
			echo( 'false' );
		}
		Yii::app()->end();
	}

}