<?php 
class YFormatter extends CFormatter {
    /* @var int The text length limit for the ShortText formatter. */
    public $shortTextLimit= 600;
    /**
     *
     * Text formatter shortening long texts and displaying the full text
     * as the span title.
     *
     * To be used in GridViews for instance.
     * @param string $value
     * @return string  Encoded and possibly html formatted string ('span' if the text is long).
     */
    public function formatShortText($value) {
        if( strlen( $value) > $this->shortTextLimit ) {
            //$retval=CHtml::tag('span',array('title'=>$value),CHtml::encode(mb_substr($value,0,$this->shortTextLimit-3,Yii::app()->charset).'...'));
					$endpos = strpos( $value, ' ', $this->shortTextLimit );
					if( $endpos !== FALSE )
						
						// if find space separator, trunc words in space
						$retval = substr( $value, 0, $endpos ) . ' . . .';
					else
						
						// if not find space separator, trunc string in middle word
						$retval = substr( $value, 0, $this->shortTextLimit-6 ) . ' . . .';
        
				} else {
            $retval = $value;
        }
				
        return CHtml::encode( $retval );
    }
}
?>