<?php

/**
 * This is the model base class for the table "regjuiciosuniv.dheredero".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Dheredero".
 *
 * Columns in table "regjuiciosuniv.dheredero" available as properties of the model,
 * followed by relations of table "regjuiciosuniv.dheredero" available as properties of the model.
 *
 * @property string $IdDHerederos
 * @property string $IdJuzgado
 * @property string $NroExpediente
 * @property string $Caratula
 * @property string $NroSentencia
 * @property string $Folio
 * @property string $FechaSentencia
 *
 * @property Juzgado $idJuzgado
 */
abstract class BaseDheredero extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'regjuiciosuniv.dheredero';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Declaratoria Heredero|Declaratoria Herederos', $n);
	}

	public static function representingColumn() {
		return 'NroExpediente';
	}

	public function rules() {
		return array(
			array('IdJuzgado, NroExpediente, Caratula, NroSentencia, Folio, FechaSentencia', 'required'),
			array('IdJuzgado', 'length', 'max'=>10),
			array('NroExpediente, NroSentencia, Folio', 'length', 'max'=>15),
			array('Caratula', 'length', 'max'=>200),
			//array('FechaSentencia', 'date', 'format'=>'yyyy-MM-dd', 'allowEmpty'=>false),
			array('FechaSentencia'	, 'ChkDate'),
			array('NroExpediente', 'formatoExpediente'),
			array('NroSentencia' , 'formatoExpediente'),
			array('Folio'				 , 'formatoExpediente'),
			array('IdDHerederos, IdJuzgado, NroExpediente, Caratula, NroSentencia, Folio, FechaSentencia', 'safe', 'on'=>'search'),
		);
	}

	public function formatoExpediente($attribute,$params) {
		$pattern = "/^(?P<numero>[1-9][0-9]*)\/(?P<anio>[0-9]+)$/";
		if(!preg_match($pattern, $this->$attribute, $matches) && $this->$attribute != "-") {
      $this->addError($attribute, $attribute.' debe ser un guion ó número/año, con número sin ceros a la izquierda y año con 4 digitos.');
		} else {
			if(preg_match($pattern, $this->$attribute, $matches)) {
				$numero = $matches['numero'];
				$anio		= $matches['anio'];
				if($numero < 1){
					$this->addError($attribute, "Número($numero) debe ser mayor o igual a 1");
				}
				$anio_actual = date("Y");
				if( $anio < 1900 || $anio > $anio_actual){
					$this->addError($attribute, "Año($anio) debe estar entre 1900 y $anio_actual");
				} else {
					return true;
				}
			}
		}
	}

	public function ChkDate($attribute,$params) {
//Yii::log( "this->$attribute=".$this->$attribute, 'warning', 'application');
		$test_arr  = explode('-', $this->$attribute);
		if(count($test_arr)!=3) {
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
			return false;
		}
		
		$day	 = $test_arr[2];
		$month = $test_arr[1];
		$year	 = $test_arr[0];

		if(!(is_numeric($day)&&is_numeric($month)&&is_numeric($year))) {
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
			return false;
		}
		
		if(checkdate($month, $day, $year)) {
//Yii::log( "checkdate=TRUE", 'warning', 'application');
			if($this->$attribute > "1899-12-31 00:00:00" && $this->$attribute < date("Y-m-d H:i:s")){
				return true;
			}else{
				$this->addError($attribute, $attribute." debe estar entre 1900-01-01 y ".date("Y-m-d"));
			}
		}else{
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
		}
	}

	public function relations() {
		return array(
			'idJuzgado' => array(self::BELONGS_TO, 'Juzgado', 'IdJuzgado'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdDHerederos' => Yii::t('app', 'Id Dherederos'),
			'IdJuzgado' => null,
			'NroExpediente' => Yii::t('app', 'Nro Expediente'),
			'Caratula' => Yii::t('app', 'Caratula'),
			'NroSentencia' => Yii::t('app', 'Nro Sentencia'),
			'Folio' => Yii::t('app', 'Folio'),
			'FechaSentencia' => Yii::t('app', 'Fecha Sentencia'),
			'idJuzgado' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdDHerederos', $this->IdDHerederos, true);
		$criteria->compare('IdJuzgado', $this->IdJuzgado);
		$criteria->compare('NroExpediente', $this->NroExpediente, true);
		$criteria->compare('Caratula', $this->Caratula, true);
		$criteria->compare('NroSentencia', $this->NroSentencia, true);
		$criteria->compare('Folio', $this->Folio, true);
		$criteria->compare('FechaSentencia', $this->FechaSentencia, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}