<?php

/**
 * This is the model base class for the table "regjuiciosuniv.estad_deudor_alimentario".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "EstadDeudorAlimentario".
 *
 * Columns in table "regjuiciosuniv.estad_deudor_alimentario" available as properties of the model,
 * and there are no model relations.
 *
 * @property string $IdDeudorAlimentario
 * @property string $FechaInscripcion
 * @property integer $Mes
 * @property integer $Anio
 * @property string $Cantidad
 *
 */
abstract class BaseEstadDeudorAlimentario extends GxActiveRecord {

	public $from_date;
	public $to_date;

	public function primaryKey()
	{
			return 'IdDeudorAlimentario';
	}

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'regjuiciosuniv.estad_deudor_alimentario';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Estadística Deud. Alimentario|Estadísticas Deud. Alimentarios', $n);
	}

	public static function representingColumn() {
		return 'FechaInscripcion';
	}

	public function rules() {
		return array(
			array('FechaInscripcion', 'required'),
			array('Mes, Anio', 'numerical', 'integerOnly'=>true),
			array('IdDeudorAlimentario', 'length', 'max'=>10),
			array('Cantidad', 'length', 'max'=>21),
			array('IdDeudorAlimentario, Mes, Anio, Cantidad', 'default', 'setOnEmpty' => true, 'value' => null),
			array('IdDeudorAlimentario, FechaInscripcion, Mes, Anio, Cantidad, from_date, to_date', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'from_date' => Yii::t('app', 'Desde'),
			'to_date'		=> Yii::t('app', 'Hasta'),
			'IdDeudorAlimentario' => Yii::t('app', 'Id Deudor Alimentario'),
			'FechaInscripcion' => Yii::t('app', 'Fecha Inscripcion'),
			'Mes' => Yii::t('app', 'Mes'),
			'Anio' => Yii::t('app', 'Año'),
			'Cantidad' => Yii::t('app', 'Cantidad'),
		);
	}

/*	public function search() {
		$criteria = new CDbCriteria;

		if(!empty($this->from_date) && empty($this->to_date))
			{
					$date			= explode('-',$this->from_date);
					$date[2]	= '01';
					$this->from_date = implode('-',$date);
					$criteria->condition = "FechaInscripcion >= '$this->from_date'";  // date is database date column field
			}elseif(!empty($this->to_date) && empty($this->from_date))
			{
					$date			= explode('-',$this->to_date);
					$date[2]	= '31';
					$this->to_date	= implode('-',$date);
					$criteria->condition = "FechaInscripcion <= '$this->to_date'";
			}elseif(!empty($this->to_date) && !empty($this->from_date))
			{
					$date			= explode('-',$this->from_date);
					$date[2]	= '01';
					$this->from_date = implode('-',$date);
					$date			= explode('-',$this->to_date);
					$date[2]	= '31';
					$this->to_date	= implode('-',$date);

					$criteria->condition = "FechaInscripcion  >= '$this->from_date' and FechaInscripcion <= '$this->to_date'";
			}		

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}*/
	
	public function search() {
		$criteria = new CDbCriteria;

		$msg = "";
		$arr_fields = array( "Desde", "Hasta" ); 
		foreach ($arr_fields as $field) {
			switch ($field) {
				case "Desde":
					$date = $this->from_date;
					break;
				case "Hasta":
					$date = $this->to_date;
					break;
				default:
					throw new CHttpException(400,'Valor de variable $field no válido '.$field);
			}			
			
			if(!empty($date)) {
				if (preg_match('/^(\d{4})-(\d{2})-(\d{2})$/', $date, $matches)) {
					$year	 = $matches[1];
					$month = $matches[2];
					$day	 = $matches[3];
					if(!checkdate($month, $day, $year)) {
						$msg = $msg . "\r\nEl campo ".$field.", tiene una fecha no valida ".$date;
					}
				}else{
					$msg = $msg . "\r\nEl campo ".$field.", tiene una fecha no valida ".$date;
				}
			}
		} //Close Foreach
		if(!empty($msg)){
			throw new CHttpException(418,$msg);
			Yii::app()->end();
		}
//Yii::log( '* * * msg:'.$msg, 'warning', 'application');
		
		if(!empty($this->from_date) && empty($this->to_date))
			{
					$date			= explode('-',$this->from_date);
					$date[2]	= '01';
					$this->from_date = implode('-',$date);
					$criteria->condition = "FechaInscripcion >= '$this->from_date'";  // date is database date column field
			}elseif(!empty($this->to_date) && empty($this->from_date))
			{
					$date			= explode('-',$this->to_date);
					$aux_date = new DateTime($this->to_date);
					$last_day_month = $aux_date->format('t');
					$date[2]	= $last_day_month;
					$this->to_date	= implode('-',$date);
					$criteria->condition = "FechaInscripcion <= '$this->to_date'";
			}elseif(!empty($this->to_date) && !empty($this->from_date))
			{
					$date			= explode('-',$this->from_date);
					$date[2]	= '01';
					$this->from_date = implode('-',$date);
					$date			= explode('-',$this->to_date);
					$aux_date = new DateTime($this->to_date);
					$last_day_month = $aux_date->format('t');
					$date[2]	= $last_day_month;
					$this->to_date	= implode('-',$date);

					$criteria->condition = "FechaInscripcion  >= '$this->from_date' and FechaInscripcion <= '$this->to_date'";
			}		

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}