<?php

/**
 * This is the model base class for the table "estad_quiebra".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "EstadQuiebra".
 *
 * Columns in table "estad_quiebra" available as properties of the model,
 * and there are no model relations.
 *
 * @property string $IdQuiebra
 * @property string $FechaRegistro
 * @property integer $Mes
 * @property integer $Anio
 * @property string $Cantidad
 *
 */
abstract class BaseEstadQuiebra extends GxActiveRecord {

	public $from_date;
	public $to_date;

	public function primaryKey()
	{
			return 'IdQuiebra';
	}

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'estad_quiebra';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Estadistica Quiebra|Estadisticas Quiebras', $n);
	}

	public static function representingColumn() {
		return 'FechaRegistro';
	}

	public function rules() {
		return array(
			array('from_date, to_date', 'required'),
			array('from_date,to_date', 'ChkDate'),
			array('from_date, to_date', 'safe', 'on'=>'search'),
			//array('FechaRegistro', 'required'),
			//array('Mes, Anio', 'numerical', 'integerOnly'=>true),
			//array('IdQuiebra', 'length', 'max'=>10),
			//array('Cantidad', 'length', 'max'=>21),
			//array('IdQuiebra, Mes, Anio, Cantidad', 'default', 'setOnEmpty' => true, 'value' => null),
			//array('from_date', 'ChkDate'),
			//array('to_date'	 , 'ChkDate'),
			//array('IdQuiebra, FechaRegistro, Mes, Anio, Cantidad, from_date, to_date', 'safe', 'on'=>'search'),
		);
	}

	public function ChkDate($attribute,$params) {
//Yii::log( "this->$attribute=".$this->$attribute, 'warning', 'application');
		if (preg_match('/^(\d{4})-(\d{2})-(\d{2})$/', $this->$attribute, $matches)) {
			$year	 = $matches[1];
			$month = $matches[2];
			$day	 = $matches[3];
		
			if(checkdate($month, $day, $year)) {
				if($this->$attribute > "1899-12-31 00:00:00" && $this->$attribute < date("Y-m-d H:i:s")){
					return true;
				}else{
					$this->addError($attribute, $attribute." debe estar entre 1900-01-01 y ".date("Y-m-d"));
				}
			}else{
				$this->addError($attribute, "El formato de ".$attribute." no es válido.");
			}
		}else{
			$this->addError($attribute, "El formato de ".$attribute." no es válido.");
		}
	}

	public function relations() {
		return array(
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'from_date' => Yii::t('app', 'Desde'),
			'to_date'		=> Yii::t('app', 'Hasta'),
			'IdQuiebra' => Yii::t('app', 'Id Quiebra'),
			'FechaRegistro' => Yii::t('app', 'Fecha Registro'),
			'Mes' => Yii::t('app', 'Mes'),
			'Anio' => Yii::t('app', 'Año'),
			'Cantidad' => Yii::t('app', 'Cantidad'),
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		/*$criteria->compare('IdQuiebra', $this->IdQuiebra, true);
		$criteria->compare('FechaRegistro', $this->FechaRegistro, true);
		$criteria->compare('Mes', $this->Mes);
		$criteria->compare('Anio', $this->Anio);
		$criteria->compare('Cantidad', $this->Cantidad, true);*/

		$msg = "";
		$arr_fields = array( "Desde", "Hasta" ); 
		foreach ($arr_fields as $field) {
			switch ($field) {
				case "Desde":
					$date = $this->from_date;
					break;
				case "Hasta":
					$date = $this->to_date;
					break;
				default:
					throw new CHttpException(400,'Valor de variable $field no válido '.$field);
			}			
			
			if(!empty($date)) {
				if (preg_match('/^(\d{4})-(\d{2})-(\d{2})$/', $date, $matches)) {
					$year	 = $matches[1];
					$month = $matches[2];
					$day	 = $matches[3];
					if(!checkdate($month, $day, $year)) {
						$msg = $msg . "\r\nEl campo ".$field.", tiene una fecha no valida ".$date;
					}
				}else{
					$msg = $msg . "\r\nEl campo ".$field.", tiene una fecha no valida ".$date;
				}
			}
		} //Close Foreach
		if(!empty($msg)){
			throw new CHttpException(418,$msg);
			Yii::app()->end();
		}
//Yii::log( '* * * msg:'.$msg, 'warning', 'application');
		
		if(!empty($this->from_date) && empty($this->to_date))
			{
					$date			= explode('-',$this->from_date);
					$date[2]	= '01';
					$this->from_date = implode('-',$date);
					$criteria->condition = "FechaRegistro >= '$this->from_date'";  // date is database date column field
			}elseif(!empty($this->to_date) && empty($this->from_date))
			{
					$date			= explode('-',$this->to_date);
					$aux_date = new DateTime($this->to_date);
					$last_day_month = $aux_date->format('t');
					$date[2]	= $last_day_month;
					$this->to_date	= implode('-',$date);
					$criteria->condition = "FechaRegistro <= '$this->to_date'";
			}elseif(!empty($this->to_date) && !empty($this->from_date))
			{
					$date			= explode('-',$this->from_date);
					$date[2]	= '01';
					$this->from_date = implode('-',$date);
					$date			= explode('-',$this->to_date);
					$aux_date = new DateTime($this->to_date);
					$last_day_month = $aux_date->format('t');
					$date[2]	= $last_day_month;
					$this->to_date	= implode('-',$date);

					$criteria->condition = "FechaRegistro  >= '$this->from_date' and FechaRegistro <= '$this->to_date'";
			}		
		//$criteria->order = 'Anio DESC, Mes DESC';
		
		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}