<?php

/**
 * This is the model base class for the table "quiebra".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Quiebra".
 *
 * Columns in table "quiebra" available as properties of the model,
 * followed by relations of table "quiebra" available as properties of the model.
 *
 * @property string $IdQuiebra
 * @property string $NroQuiebra
 * @property string $AnioQuiebra
 * @property string $FechaInicio
 * @property string $FechaRegistro
 * @property string $NroExpediente
 * @property string $Caratula
 * @property string $Profesional
 * @property string $IdJuzgado
 * @property string $IdEstado
 * @property string $Nota
 *
 * @property EstadoQuiebra $idEstado
 * @property Juzgado $idJuzgado
 */
abstract class BaseQuiebra extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'quiebra';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Quiebra|Quiebras', $n);
	}

	public static function representingColumn() {
		return 'Caratula';
	}

	public function rules() {
		return array(
			array('NroQuiebra, AnioQuiebra, FechaInicio, FechaRegistro, Caratula, Profesional, IdJuzgado, IdEstado', 'required'),
			array('NroQuiebra, AnioQuiebra, IdJuzgado, IdEstado', 'length', 'max'=>10),
			array('NroExpediente', 'length', 'max'=>15),
			array('Caratula', 'length', 'max'=>500),
			array('Profesional', 'length', 'max'=>45),
			array('Nota', 'length', 'max'=>800),
			array('NroExpediente, Nota', 'default', 'setOnEmpty' => true, 'value' => null),
			array('FechaInicio',	 'ChkDate'),
			array('FechaRegistro', 'ChkDate'),
			array('NroExpediente', 'formatoExpediente'),
			array('NroQuiebra',  'numerical', 'integerOnly'=>true, 'min'=>1, 'max'=>4294967295),
			array('AnioQuiebra', 'numerical', 'integerOnly'=>true, 'min'=>1900, 'max'=>date("Y")),
			array('IdQuiebra, NroQuiebra, AnioQuiebra, FechaInicio, FechaRegistro, NroExpediente, Caratula, Profesional, IdJuzgado, IdEstado, Nota', 'safe', 'on'=>'search'),
		);
	}

	public function formatoExpediente($attribute,$params) {
		$pattern = "/^(?P<numero>[1-9][0-9]*)\/(?P<anio>[0-9]+)$/";
		if(!preg_match($pattern, $this->$attribute, $matches) && $this->$attribute != "-") {
      $this->addError($attribute, $attribute.' debe ser un guion ó número/año, con número sin ceros a la izquierda y año con 4 digitos.');
		} else {
			if(preg_match($pattern, $this->$attribute, $matches)) {
				$numero = $matches['numero'];
				$anio		= $matches['anio'];
				if($numero < 1){
					$this->addError($attribute, "Número($numero) debe ser mayor o igual a 1");
				}
				$anio_actual = date("Y");
				if( $anio < 1900 || $anio > $anio_actual){
					$this->addError($attribute, "Año($anio) debe estar entre 1900 y $anio_actual");
				} else {
					return true;
				}
			}
		}
	}

	public function ChkDate($attribute,$params) {
//Yii::log( "this->$attribute=".$this->$attribute, 'warning', 'application');
		
		/*
		$test_arr  = explode('-', $this->$attribute);
		if(count($test_arr)!=3) {
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
			return false;
		}
		
		$day	 = $test_arr[2];
		$month = $test_arr[1];
		$year	 = $test_arr[0];

		if(!(is_numeric($day)&&is_numeric($month)&&is_numeric($year))) {
			$this->addError($attribute, "El formato de ".$attribute." es inválido.");
			return false;
		}
		*/
		if (preg_match('/^(\d{4})-(\d{2})-(\d{2})$/', $this->$attribute, $matches)) {
			$year	 = $matches[1];
			$month = $matches[2];
			$day	 = $matches[3];
		} else {
			$this->addError($attribute, "El formato de ".$attribute." no es válido.");
			return false;
		}
		
		if(checkdate($month, $day, $year)) {
//Yii::log( "checkdate=TRUE", 'warning', 'application');
			if($this->$attribute > "1899-12-31 00:00:00" && $this->$attribute < date("Y-m-d H:i:s")){
				return true;
			}else{
				$this->addError($attribute, $attribute." debe estar entre 1900-01-01 y ".date("Y-m-d"));
			}
		}else{
			$this->addError($attribute, "El formato de ".$attribute." no es válido.");
		}
	}

	public function relations() {
		return array(
			'idEstado' => array(self::BELONGS_TO, 'EstadoQuiebra', 'IdEstado'),
			'idJuzgado' => array(self::BELONGS_TO, 'Juzgado', 'IdJuzgado'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdQuiebra'		=> Yii::t('app', 'Id Quiebra'),
			'NroQuiebra'	=> Yii::t('app', 'Nro Quiebra'),
			'AnioQuiebra'	=> Yii::t('app', 'Año Quiebra'),
			'FechaInicio'	=> Yii::t('app', 'Fecha Inicio'),
			'FechaRegistro' => Yii::t('app', 'Fecha Registro'),
			'NroExpediente' => Yii::t('app', 'Nro Expediente'),
			'Caratula'		=> Yii::t('app', 'Carátula'),
			'Profesional'	=> Yii::t('app', 'Profesional'),
			'IdJuzgado'		=> null,
			//'IdEstado'		=> null,
			'IdEstado'		=> Yii::t('app', 'Estado'),
			'Nota'			=> Yii::t('app', 'Nota'),
			//'idEstado'		=> null,
			'idEstado'		=> Yii::t('app', 'Estado'),
			'idJuzgado'		=> null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdQuiebra', $this->IdQuiebra, true);
		$criteria->compare('NroQuiebra', $this->NroQuiebra, true);
		$criteria->compare('AnioQuiebra', $this->AnioQuiebra, true);
		$criteria->compare('FechaInicio', $this->FechaInicio, true);
		$criteria->compare('FechaRegistro', $this->FechaRegistro, true);
		$criteria->compare('NroExpediente', $this->NroExpediente, true);
		$criteria->compare('Caratula', $this->Caratula, true);
		$criteria->compare('Profesional', $this->Profesional, true);
		$criteria->compare('IdJuzgado', $this->IdJuzgado);
		$criteria->compare('IdEstado', $this->IdEstado);
		$criteria->compare('Nota', $this->Nota, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}