<?php

class SentenciaController extends GxController {

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'Sentencia'),
		));
	}

	public function actionCreate() {
		$model = new Sentencia;


		if (isset($_POST['Sentencia'])) {
			$model->setAttributes($_POST['Sentencia']);
			$relatedData = array(
				'firmantes' => $_POST['Sentencia']['firmantes'] === '' ? null : $_POST['Sentencia']['firmantes'],
				);

			if ($model->saveWithRelated($relatedData)) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdSentencia));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'Sentencia');


		if (isset($_POST['Sentencia'])) {
			$model->setAttributes($_POST['Sentencia']);
			$relatedData = array(
				'firmantes' => $_POST['Sentencia']['firmantes'] === '' ? null : $_POST['Sentencia']['firmantes'],
				);

			if ($model->saveWithRelated($relatedData)) {
				$this->redirect(array('view', 'id' => $model->IdSentencia));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'Sentencia')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Sentencia');
		
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Sentencia('search');
		$model->unsetAttributes();

		if (isset($_GET['Sentencia'])) {
			$model->setAttributes($_GET['Sentencia']);
			// Get search keywords to highlight
			Yii::app()->session['arrFieldsSent'] = array( $_GET['Sentencia']['Caratula'],
																							 		  $_GET['Sentencia']['Texto'],
																						 		 );
Yii::log("SentenciaControler opLogTexto = ".$_GET['Sentencia']['opLogTexto'], 'info', 'application');
			Yii::app()->session['opcionCaratulaSent']  = $_GET['Sentencia']['opLogCaratula'];
			Yii::app()->session['opcionTextoSent']		 = $_GET['Sentencia']['opLogTexto'];
		}
		
		$this->render('admin', array(
			'model' => $model,
		));
	}

}