<?php

class VistaSumarioController extends GxController {


	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'VistaSumario'),
			'model_sumario' => $this->loadModel($id, 'Sumario'),
		));
	}

	public function actionCreate() {
		$model = new VistaSumario;


		if (isset($_POST['VistaSumario'])) {
			$model->setAttributes($_POST['VistaSumario']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdSumario));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'VistaSumario');


		if (isset($_POST['VistaSumario'])) {
			$model->setAttributes($_POST['VistaSumario']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdSumario));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'VistaSumario')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('VistaSumario');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new VistaSumario('search');
		$model->unsetAttributes();

		if (isset($_GET['VistaSumario'])) {
			$model->setAttributes($_GET['VistaSumario']);
			// Get search keywords to highlight
			Yii::app()->session['arrFields'] = array( $_GET['VistaSumario']['Tema'],
																							  $_GET['VistaSumario']['Texto'],
																						 );
			Yii::app()->session['opLogTema']  = $_GET['VistaSumario']['opLogTema'];
			Yii::app()->session['opLogTexto'] = $_GET['VistaSumario']['opLogTexto'];
		}

		$this->render('admin', array(
			'model' => $model,
		));
	}

}