<?php

/**
 * This is the model base class for the table "bdjuris.firmante".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Firmante".
 *
 * Columns in table "bdjuris.firmante" available as properties of the model,
 * followed by relations of table "bdjuris.firmante" available as properties of the model.
 *
 * @property string $idFirmante
 * @property string $IdTribunal
 * @property string $Nombre
 *
 * @property Tribunal $idTribunal
 * @property Sentencia[] $sentencias
 */
abstract class BaseFirmante extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'bdjuris.firmante';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Firmante|Firmantes', $n);
	}

	public static function representingColumn() {
		return 'Nombre';
	}

	public function rules() {
		return array(
			array('idFirmante, IdTribunal, Nombre', 'required'),
			array('idFirmante, IdTribunal', 'length', 'max'=>10),
			array('Nombre', 'length', 'max'=>150),
			array('idFirmante, IdTribunal, Nombre', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'idTribunal' => array(self::BELONGS_TO, 'Tribunal', 'IdTribunal'),
			'sentencias' => array(self::MANY_MANY, 'Sentencia', 'firmante_sentencia(IdFirmante, IdSentencia)'),
		);
	}

	public function pivotModels() {
		return array(
			'sentencias' => 'FirmanteSentencia',
		);
	}

	public function attributeLabels() {
		return array(
			'idFirmante' => Yii::t('app', 'Id Firmante'),
			'IdTribunal' => null,
			'Nombre' => Yii::t('app', 'Nombre'),
			'idTribunal' => null,
			'sentencias' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('idFirmante', $this->idFirmante, true);
		$criteria->compare('IdTribunal', $this->IdTribunal);
		$criteria->compare('Nombre', $this->Nombre, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}