<?php

/**
 * This is the model base class for the table "bdjuris.normativa".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Normativa".
 *
 * Columns in table "bdjuris.normativa" available as properties of the model,
 * followed by relations of table "bdjuris.normativa" available as properties of the model.
 *
 * @property string $IdNormativa
 * @property string $IdSumario
 * @property string $IdTipoNormativa
 * @property string $Jurisdiccion
 * @property string $Numero
 *
 * @property Articulo[] $articulos
 * @property Sumario $idSumario
 * @property Tiponormativa $idTipoNormativa
 */
abstract class BaseNormativa extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'bdjuris.normativa';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Normativa|Normativas', $n);
	}

	public static function representingColumn() {
		return 'Numero';
	}

	public function rules() {
		return array(
			array('IdNormativa, IdSumario, IdTipoNormativa, Jurisdiccion', 'required'),
			array('IdNormativa, IdSumario, IdTipoNormativa', 'length', 'max'=>10),
			array('Jurisdiccion', 'length', 'max'=>13),
			array('Numero', 'length', 'max'=>300),
			array('Numero', 'default', 'setOnEmpty' => true, 'value' => null),
			array('IdNormativa, IdSumario, IdTipoNormativa, Jurisdiccion, Numero', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'articulos' => array(self::HAS_MANY, 'Articulo', 'IdNormativa'),
			'idSumario' => array(self::BELONGS_TO, 'Sumario', 'IdSumario'),
			'idTipoNormativa' => array(self::BELONGS_TO, 'Tiponormativa', 'IdTipoNormativa'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdNormativa' => Yii::t('app', 'Id Normativa'),
			'IdSumario' => null,
			'IdTipoNormativa' => null,
			'Jurisdiccion' => Yii::t('app', 'Jurisdiccion'),
			'Numero' => Yii::t('app', 'Numero'),
			'articulos' => null,
			'idSumario' => null,
			'idTipoNormativa' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdNormativa', $this->IdNormativa, true);
		$criteria->compare('IdSumario', $this->IdSumario);
		$criteria->compare('IdTipoNormativa', $this->IdTipoNormativa);
		$criteria->compare('Jurisdiccion', $this->Jurisdiccion, true);
		$criteria->compare('Numero', $this->Numero, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}