<?php

/**
 * This is the model base class for the table "bdjuris.sentencia".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Sentencia".
 *
 * Columns in table "bdjuris.sentencia" available as properties of the model,
 * followed by relations of table "bdjuris.sentencia" available as properties of the model.
 *
 * @property string $IdSentencia
 * @property string $IdTribunal
 * @property string $IdMateriaSent
 * @property string $Tipo
 * @property string $NroInterno
 * @property string $Fecha
 * @property string $Caratula
 * @property string $Actora
 * @property string $Demandada
 * @property string $Sobre
 * @property string $Texto
 * @property integer $Publica
 *
 * @property Firmante[] $firmantes
 * @property Materiasent $idMateriaSent
 * @property Tribunal $idTribunal
 * @property Sumario[] $sumarios
 */
abstract class BaseSentencia extends GxActiveRecord {

	public $opLogCaratula;
	public $opLogTexto;
	public $from_date;
	public $to_date;

	// Todos los SELECT obtienen solo sentencias publicas
	public function defaultScope() {
		return array(
			'condition'=>"Publica=1",
		);
	}
	
	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'bdjuris.sentencia';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Sentencia|Sentencias', $n);
	}

	public static function representingColumn() {
		return 'NroInterno';
	}

	public function rules() {
		return array(
			array('IdSentencia, IdTribunal, IdMateriaSent, Tipo, NroInterno, Fecha, Caratula, Actora, Demandada, Sobre, Texto, Publica', 'required'),
			array('Publica', 'numerical', 'integerOnly'=>true),
			array('IdSentencia, IdTribunal, IdMateriaSent, NroInterno', 'length', 'max'=>10),
			array('Tipo', 'length', 'max'=>14),
			array('Caratula', 'length', 'max'=>400),
			array('Actora, Demandada, Sobre', 'length', 'max'=>150),
			array('opLogCaratula, opLogTexto', 'numerical', 'integerOnly'=>true, 'min'=>0, 'max'=>2),
			array('from_date,to_date', 'date', 'format'=>'dd-MM-yyyy', 'allowEmpty'=>false),
			array('IdSentencia, IdTribunal, IdMateriaSent, Tipo, NroInterno, Fecha, Caratula, Actora, Demandada, Sobre, Texto, Publica, opLogCaratula, opLogTexto, from_date, to_date', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'firmantes' => array(self::MANY_MANY, 'Firmante', 'firmante_sentencia(IdSentencia, IdFirmante)'),
			'idMateriaSent' => array(self::BELONGS_TO, 'Materiasent', 'IdMateriaSent'),
			'idTribunal' => array(self::BELONGS_TO, 'Tribunal', 'IdTribunal'),
			'sumarios' => array(self::HAS_MANY, 'Sumario', 'IdSentencia'),
		);
	}

	public function pivotModels() {
		return array(
			'firmantes' => 'FirmanteSentencia',
		);
	}

	public function attributeLabels() {
		return array(
			'from_date' 		=> Yii::t('app', 'Desde'),
			'to_date'				=> Yii::t('app', 'Hasta'),
			'IdSentencia' 	=> Yii::t('app', 'Id Sentencia'),
			'IdTribunal' 		=> Yii::t('app', 'Tribunal'),
			'IdMateriaSent' => Yii::t('app', 'Materia'),  // Duplicado
			'Tipo' 					=> Yii::t('app', 'Tipo'),
			'NroInterno' 		=> Yii::t('app', 'Nro Sent'),
			'Fecha' 				=> Yii::t('app', 'Fecha'),
			'Caratula' 			=> Yii::t('app', 'Caratula'),
			'Actora' 				=> Yii::t('app', 'Actora'),
			'Demandada' 		=> Yii::t('app', 'Demandada'),
			'Sobre' 				=> Yii::t('app', 'Sobre'),
			'Texto' 				=> Yii::t('app', 'Texto'),
			'Publica' 			=> Yii::t('app', 'Publica'),
			'firmantes' 		=> null,
			//'idMateriaSent' => Yii::t('app', 'Materia'),  // Duplicado
			'idTribunal' 		=> null,
			'sumarios' 			=> null,
		);
	}

	public function search() {
		$oplog = 'and';
		$criteria = new CDbCriteria;
		$from_date_MySQL = '';
		$to_date_MySQL 	 = '';

		$criteria->compare('IdSentencia', 	$this->IdSentencia, 	false);
		$criteria->compare('IdTribunal', 		$this->IdTribunal,		false);
		$criteria->compare('IdMateriaSent', $this->IdMateriaSent, false);
		$criteria->compare('Tipo', 					$this->Tipo, 					false);
		$criteria->compare('NroInterno', 		$this->NroInterno, 		false);

		//$criteria->compare('Fecha', 				$this->Fecha, 				false);
		//$criteria->compare('Caratula', 			$this->Caratula, 			true);

		if ($this->opLogCaratula == '2'){
			// Buscar frase exacta
			$criteria->compare('Caratula', $this->Caratula, true);
		} else {
			// Buscar todas las palabras o algunas palabras
			if ($this->Caratula) {
				if (strpos(trim($this->Caratula),' ') !== false) {
					// Buscar multiples palabras
					if($this->opLogCaratula == '0')
						$oplog = 'and';
					elseif($this->opLogCaratula == '1')
						$oplog = 'or';
					
					$search_words = explode(' ', $this->Caratula);               
					foreach($search_words as $words) {
						$criteria->compare('Caratula', $words, true, $oplog);
					} 
				} else {
					// Buscar una palabra simple
					$criteria->compare('Caratula', $this->Caratula, true);
				}
			}		
		}
		
		$criteria->compare('Actora', 				$this->Actora, 				true);
		$criteria->compare('Demandada', 		$this->Demandada, 		true);
		$criteria->compare('Sobre', 				$this->Sobre, 				true);
		//$criteria->compare('Texto', 				$this->Texto, 				true);
		// Campo Texto
		if ($this->opLogTexto == '2'){
		
			// Buscar frase exacta
//Yii::log("this->Texto = ".$this->Texto, 'info', 'application');
			$criteria->compare('Texto', $this->Texto, true);
		} else {
			
			// Buscar todas las palabras o algunas palabras
			if ($this->Texto) {
				if (strpos(trim($this->Texto),' ') !== false) {
					// Buscar multiples palabras
					if($this->opLogTexto == '0')
						$oplog = 'and';
					elseif($this->opLogTexto == '1')
						$oplog = 'or';
					
					$search_words = explode(' ', $this->Texto);               
					foreach($search_words as $words) {
						$criteria->compare('Texto', $words, true, $oplog);
					} 
				} else {
					// Buscar una palabra simple
					$criteria->compare('Texto', $this->Texto, true);
				}
			}		
		}

		$this->from_date = trim( $this->from_date );
		$this->to_date 	 = trim( $this->to_date );
		if(!empty($this->from_date) && empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'dd-MM-yyyy'));
				$criteria->addCondition( "Fecha >= '$from_date_MySQL'" );
			}
		elseif(empty($this->from_date) && !empty($this->to_date))
			{
				$to_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'dd-MM-yyyy'));
				$criteria->addCondition( "Fecha <= '$to_date_MySQL'" );
			}
		elseif(!empty($this->from_date) && !empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'dd-MM-yyyy'));
				$to_date_MySQL 	 = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'dd-MM-yyyy'));
				$criteria->addCondition( "Fecha BETWEEN '$from_date_MySQL' AND '$to_date_MySQL'");
			}		

//Yii::log("* * *criteria->condition = ".$criteria->condition, 'info', 'application');
		
		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}