<?php

/**
 * This is the model base class for the table "bdjuris.sumario".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Sumario".
 *
 * Columns in table "bdjuris.sumario" available as properties of the model,
 * followed by relations of table "bdjuris.sumario" available as properties of the model.
 *
 * @property string $IdSumario
 * @property string $IdSentencia
 * @property string $Tema
 * @property string $Texto
 *
 * @property Normativa[] $normativas
 * @property Sentencia $idSentencia
 * @property Materia[] $materias
 * @property Voto[] $votos
 */
abstract class BaseSumario extends GxActiveRecord {

	// Todos los SELECT obtienen solo sumarios publicos
	public function defaultScope() {
		return array(
				'with' =>'idSentencia',
				'condition' => 'idSentencia.Publica = 1',
		);
	}
	
	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'bdjuris.sumario';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Sumario|Sumarios', $n);
	}

	public static function representingColumn() {
		return 'Tema';
	}

	public function rules() {
		return array(
			array('IdSumario, IdSentencia, Tema, Texto', 'required'),
			array('IdSumario, IdSentencia', 'length', 'max'=>10),
			array('Tema', 'length', 'max'=>700),
			array('IdSumario, IdSentencia, Tema, Texto', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'normativas' => array(self::HAS_MANY, 'Normativa', 'IdSumario'),
			'idSentencia' => array(self::BELONGS_TO, 'Sentencia', 'IdSentencia'),
			'materias' => array(self::MANY_MANY, 'Materia', 'sumario_materia(IdSumario, IdMateria)'),
			'votos' => array(self::HAS_MANY, 'Voto', 'IdSumario'),
		);
	}

	public function pivotModels() {
		return array(
			'materias' => 'SumarioMateria',
		);
	}

	public function attributeLabels() {
		return array(
			'IdSumario' => Yii::t('app', 'Id Sumario'),
			'IdSentencia' => Yii::t('app', 'Nro Sent'),
			'Tema' => Yii::t('app', 'Tema'),
			'Texto' => Yii::t('app', 'Texto'),
			'normativas' => null,
			'idSentencia' => null,
			'materias' => null,
			'votos' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdSumario', $this->IdSumario, true);
		$criteria->compare('IdSentencia', $this->IdSentencia);
		$criteria->compare('Tema', $this->Tema, true);
		$criteria->compare('Texto', $this->Texto, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}