<?php

/**
 * This is the model base class for the table "bdjuris.vista_sumario".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "VistaSumario".
 *
 * Columns in table "bdjuris.vista_sumario" available as properties of the model,
 * and there are no model relations.
 *
 * @property string $IdSumario
 * @property string $Tema
 * @property string $Texto
 * @property string $IdMateria
 * @property string $Materia
 * @property string $Actora
 * @property string $Demandada
 * @property string $Sobre
 * @property string $IdFirmante
 * @property string $Firmante
 * @property string $IdTribunal
 * @property string $Tribunal
 * @property string $Fecha
 * @property string $NroInterno
 * @property string $IdSentencia
 *
 */
abstract class BaseVistaSumario extends GxActiveRecord {
	public $opLogTema;
	public $opLogTexto;
	public $from_date;
	public $to_date;
	
	public function primaryKey()
	{
			return 'IdSumario';
	}

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'bdjuris.vista_sumario';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Sumario|Sumarios', $n);
	}

	public static function representingColumn() {
		return 'Tema';
	}

	public function rules() {
		return array(
			array('IdSumario, Tema, Texto, Actora, Demandada, Sobre, IdTribunal, Tribunal, Fecha, NroInterno, IdSentencia', 'required'),
			array('IdSumario, IdMateria, IdFirmante, IdTribunal, NroInterno, IdSentencia', 'length', 'max'=>10),
			array('Tema', 'length', 'max'=>700),
			array('Materia, Tribunal', 'length', 'max'=>45),
			array('Actora, Demandada, Sobre, Firmante', 'length', 'max'=>150),
			array('IdMateria, Materia, IdFirmante, Firmante', 'default', 'setOnEmpty' => true, 'value' => null),
			array('opLogTema, opLogTexto', 'numerical', 'integerOnly'=>true, 'min'=>0, 'max'=>2),
			array('Fecha', 'date', 'format'=>'d-M-yyyy'),
			array('from_date,to_date', 'date', 'format'=>'dd-MM-yyyy', 'allowEmpty'=>false),
			array('IdSumario, Tema, Texto, IdMateria, Materia, Actora, Demandada, Sobre, IdFirmante, Firmante, IdTribunal, Tribunal, Fecha, NroInterno, IdSentencia, opLogTema, opLogTexto, from_date, to_date', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'from_date' 	=> Yii::t('app', 'Desde'),
			'to_date'			=> Yii::t('app', 'Hasta'),
			'IdSumario' 	=> Yii::t('app', 'Id Sumario'),
			'Tema' 				=> Yii::t('app', 'Voces'),
			'Texto' 			=> Yii::t('app', 'Texto'),
			'IdMateria' 	=> Yii::t('app', 'Id Materia'),
			'Materia' 		=> Yii::t('app', 'Materia'),
			'Actora' 			=> Yii::t('app', 'Actora'),
			'Demandada' 	=> Yii::t('app', 'Demandada'),
			'Sobre' 			=> Yii::t('app', 'Sobre'),
			'IdFirmante' 	=> Yii::t('app', 'Id Firmante'),
			'Firmante' 		=> Yii::t('app', 'Firmante'),
			'IdTribunal' 	=> Yii::t('app', 'Id Tribunal'),
			'Tribunal' 		=> Yii::t('app', 'Tribunal'),
			'Fecha' 			=> Yii::t('app', 'Fecha'),
			'NroInterno' 	=> Yii::t('app', 'Nro Sent'),
			'IdSentencia' => Yii::t('app', 'Id Sentencia'),
		);
	}

	public function search() {
		$oplog = 'and';
		$criteria = new CDbCriteria;
		$from_date_MySQL = '';
		$to_date_MySQL 	 = '';

		$criteria->distinct = true;
		$criteria->select = 'NroInterno, IdSumario, Tema, Texto, Materia';
		$criteria->compare('IdSumario', 	$this->IdSumario, 	false);
		//$criteria->compare('Tema', 				$this->Tema, 				true);
		// Campo Tema
		if ($this->opLogTema == '2'){
		
			// Buscar frase exacta
			$criteria->compare('Tema', $this->Tema, true);
		} else {
			
			// Buscar todas las palabras o algunas palabras
			if ($this->Tema) {
				if (strpos(trim($this->Tema),' ') !== false) {
					// Buscar multiples palabras
					if($this->opLogTema == '0')
						$oplog = 'and';
					elseif($this->opLogTema == '1')
						$oplog = 'or';
					
					$search_words = explode(' ', $this->Tema);               
					foreach($search_words as $words) {
						$criteria->compare('Tema', $words, true, $oplog);
					} 
				} else {
					// Buscar una palabra simple
					$criteria->compare('Tema', $this->Tema, true);
				}
			}		
		}

		//$criteria->compare('Texto', 			$this->Texto, 			true);
		// Campo Texto
		if ($this->opLogTexto == '2'){
		
			// Buscar frase exacta
			$criteria->compare('Texto', $this->Texto, true);
		} else {
			
			// Buscar todas las palabras o algunas palabras
			if ($this->Texto) {
				if (strpos(trim($this->Texto),' ') !== false) {
					// Buscar multiples palabras
					if($this->opLogTexto == '0')
						$oplog = 'and';
					elseif($this->opLogTexto == '1')
						$oplog = 'or';
					
					$search_words = explode(' ', $this->Texto);               
					foreach($search_words as $words) {
						$criteria->compare('Texto', $words, true, $oplog);
					} 
				} else {
					// Buscar una palabra simple
					$criteria->compare('Texto', $this->Texto, true);
				}
			}		
		}

		$criteria->compare('IdMateria', 	$this->IdMateria, 	true);
		$criteria->compare('Materia', 		$this->Materia, 		true);
		$criteria->compare('Actora', 			$this->Actora, 			true);
		$criteria->compare('Demandada', 	$this->Demandada, 	true);
		$criteria->compare('Sobre', 			$this->Sobre, 			true);
		$criteria->compare('IdFirmante',	$this->IdFirmante,	true);
		$criteria->compare('Firmante', 		$this->Firmante, 		true);
		$criteria->compare('IdTribunal', 	$this->IdTribunal, 	true);
		$criteria->compare('Tribunal', 		$this->Tribunal, 		true);

		$this->from_date = trim( $this->from_date );
		$this->to_date 	 = trim( $this->to_date );
		if(!empty($this->from_date) && empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'dd-MM-yyyy'));
				$criteria->addCondition( "Fecha >= '$from_date_MySQL'" );
			}
		elseif(empty($this->from_date) && !empty($this->to_date))
			{
				$to_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'dd-MM-yyyy'));
				$criteria->addCondition( "Fecha <= '$to_date_MySQL'" );
			}
		elseif(!empty($this->from_date) && !empty($this->to_date))
			{
				$from_date_MySQL = date('Y-m-d', CDateTimeParser::parse($this->from_date, 'dd-MM-yyyy'));
				$to_date_MySQL 	 = date('Y-m-d', CDateTimeParser::parse($this->to_date, 'dd-MM-yyyy'));
				$criteria->addCondition( "Fecha BETWEEN '$from_date_MySQL' AND '$to_date_MySQL'");
			}		
		
		$criteria->compare('NroInterno', 	$this->NroInterno, 	false);
		$criteria->compare('IdSentencia', $this->IdSentencia, false);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}