<?php

class ResolucionController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			);
}

public function accessRules() {
	return array(
			array('allow',
				'actions'=>array('index','view','admin', 'download'),
				'users'=>array('*'),
				),
			array('allow', 
				'actions'=>array('ClusterMap', 'HeatMap', 'Stats', 
												 'GetJuzgados', 'GetDepartamentos', 'getMarkers', 'getHeatMarkers', 'DeleteFile'),
				'users'=>array('@'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create', 'update', 'delete'),
				'users'=>array('informatica', 'M.Whitaker', 'N.Rios'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$model = $this->loadModel($id, 'Resolucion');
		$criteria = new CDbCriteria();
		$criteria->select = '*';//'IdEstandard';
		$criteria->condition = 'IdResolucion = :id_resolucion';
		$criteria->params = array(':id_resolucion' => $model->IdResolucion);
		$arrEstandares = Estandardresol::model()->findAll($criteria);
		$Lista = array();
		foreach( $arrEstandares as $Estandar ){
			$Lista[] = 'E'.$Estandar->IdEstandard;
			foreach( $Estandar->subestandardresols as $Subestandar ){
				$Lista[] = 'S'.$Subestandar->IdSubEstandard;
			}
		}
		$model->ListaEstandares = $Lista;
		
		$this->render('view', array(
			'model' => $model,
		));
	}

	public function actionCreate() {
		$model = new Resolucion;
		$model->IdProvincia = 10; //Establece Catamarca por defecto
		$model->ListaEstandares = array();
		//$dir = Yii::getPathOfAlias('application.uploads');
		$dir = Yii::app()->params['UploadDir'];

		if (isset($_POST['Resolucion'])) {
			$model->setAttributes($_POST['Resolucion']);
			if ( is_array($_POST['Resolucion']['ListaEstandares']) ){
				$Lista = array();
				foreach($_POST['Resolucion']['ListaEstandares'] as $key => $value){
					if( !$value == 0 )
						$Lista[] = $key;
				}
			}
			$model->ListaEstandares = $Lista;

			$uploadfile = CUploadedFile::getInstance($model, 'Archivo');
			if($uploadfile !== null){ // only do if file is really uploaded
				$filename = rand(1,9999999).'-'.$uploadfile->name;
				$model->Archivo = $filename;
			}	

			if ($model->save()) {
				
				if($uploadfile !== null) // validate to save file
					$uploadfile->saveAs($dir.DIRECTORY_SEPARATOR.$filename);
							
				// Save Estandares y Subestandares
				$resultSave = $this->SaveEstandares( $model->IdResolucion, $_POST['Resolucion']['ListaEstandares'] );
				
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdResolucion));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function SaveEstandares( $id_resolucion, $ListaEstandares ) {
		$flag_save = true;
		
		if ( is_array($ListaEstandares) ){
			foreach($ListaEstandares as $key => $value){
				if( !$value == 0 ) {
					$type = strtoupper(substr($key, 0, 1));
					if( $type == "E" ) {
						$cmd = Yii::app()->db->createCommand();
						$cmd->select = 'IdResolucion, IdEstandard';
						$cmd->from	 = 'estandardresol';
						$cmd->where	 = 'IdResolucion='.$id_resolucion.' and IdEstandard='.$value;
						$row = $cmd->queryRow();
						if($row == false) {
							$cmd2 = Yii::app()->db->createCommand();
							if( !$cmd2->insert('estandardresol', array('IdResolucion'=>$id_resolucion, 'IdEstandard' => $value)) ) {
								$flag_save = false;
								$LastInsertID = null;
							} else {
								$LastInsertID = Yii::app()->db->getLastInsertID();
							}
						} else {
							$LastInsertID = $row['IdEstandardResol'];
							$flag_save = false;
						}
					}
					
					if( $type == "S" ) {
						$cmd = Yii::app()->db->createCommand();
						$cmd->select = 'IdEstandardResol, IdSubEstandard';
						$cmd->from	 = 'subestandardresol';
						$cmd->where	 = 'IdEstandardResol='.$LastInsertID.' and IdSubEstandard='.$value;
						$result = $cmd->query();
						if(count($result) == 0) {
							$cmd2 = Yii::app()->db->createCommand();
							if( !$cmd2->insert('subestandardresol', array('IdEstandardResol'=>$LastInsertID, 'IdSubEstandard' => $value)) )
								$flag_save = false;
						} else {
							$flag_save = false;
						}
					}
				}
			}
			return $flag_save;
		}
	}

	public function actionUpdate($id) {
		$model	 = $this->loadModel($id, 'Resolucion');
		$criteria = new CDbCriteria();
		$criteria->select = '*';//'IdEstandard';
		$criteria->condition = 'IdResolucion = :id_resolucion';
		$criteria->params = array(':id_resolucion' => $model->IdResolucion);
		$arrEstandares = Estandardresol::model()->findAll($criteria);
		$Lista = array();
		foreach( $arrEstandares as $Estandar ){
			$Lista[] = 'E'.$Estandar->IdEstandard;
			foreach( $Estandar->subestandardresols as $Subestandar ){
				$Lista[] = 'S'.$Subestandar->IdSubEstandard;
			}
		}
		$model->ListaEstandares = $Lista;
		
		$oldfile = $model->Archivo;
		//$dir		 = Yii::getPathOfAlias('application.uploads');
		$dir = Yii::app()->params['UploadDir'];

		if (isset($_POST['Resolucion'])) {
			$model->setAttributes($_POST['Resolucion']);

			$upload = CUploadedFile::getInstance($model, 'Archivo');
			if ($upload != null) {
				// Establecer nombre de nuevo archivo
				$filename = rand(1,9999999).'-'.$upload->name;
				$model->Archivo = $filename;
			}

			if ($model->save()) {
				if ($upload != null) {
					// Cargar nuevo archivo y eliminar viejo
					$upload->saveAs($dir.DIRECTORY_SEPARATOR.$filename);
					
					if( !empty($oldfile) ) {
						$filepath = $dir.DIRECTORY_SEPARATOR.$oldfile;
						unlink($filepath);
					}
				}
				
				foreach( $arrEstandares as $Estandar ){
					foreach( $Estandar->subestandardresols as $Subestandar ){
						$Subestandar->delete();
					}
					$Estandar->delete();
				}
				$resultSave = $this->SaveEstandares( $model->IdResolucion, $_POST['Resolucion']['ListaEstandares'] );

				$this->redirect(array('view', 'id' => $model->IdResolucion));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			//$this->loadModel($id, 'Resolucion')->delete();
			$model = $this->loadModel($id, 'Resolucion');

			$filename = $model->Archivo;
			//$filepath = Yii::getPathOfAlias('application.uploads').'\\'.$filename;
			$filepath = Yii::app()->params['UploadDir'].DIRECTORY_SEPARATOR.$filename;
			if( isset($filename) && file_exists( $filepath ) ) 
				unlink($filepath);
			
			$criteria = new CDbCriteria();
			$criteria->select = '*';//'IdEstandard';
			$criteria->condition = 'IdResolucion = :id_resolucion';
			$criteria->params = array(':id_resolucion' => $model->IdResolucion);
			$arrEstandares = Estandardresol::model()->findAll($criteria);
			foreach( $arrEstandares as $Estandar ){
				foreach( $Estandar->subestandardresols as $Subestandar ){
					$Subestandar->delete();
				}
				$Estandar->delete();
			}
			$model->delete();
			
			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionDeleteFile() {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$id	 = $_POST['id'];
			$model = $this->loadModel($id, 'Resolucion');
			$filename = $model->Archivo;
			//$filepath = Yii::getPathOfAlias('application.uploads').'\\'.$filename;
			$filepath = Yii::app()->params['UploadDir'].DIRECTORY_SEPARATOR.$filename;
			if( isset($filename) && file_exists( $filepath ) ) {
				if (unlink($filepath)) {
					$model->Archivo = null;
					if ($model->save(false)){
						echo "{err:Ok}";
					}
					else
						echo "{err:Data not saving}";
				} else {
					echo "{err:File not delete}";
				}
			} else {
				// file not set or file not exists
				$model->Archivo = null;
				if ($model->save(false))
					echo "{err:'Data update, file not exists' }";
				else
					echo "{err:'Data not saving, file not exists' }";
			}
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Resolucion');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Resolucion('search');
		$model->unsetAttributes();

		if (isset($_GET['Resolucion']))
			$model->setAttributes($_GET['Resolucion']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

	public function actionDownload($id) {	        
		$model = $this->loadModel($id, 'Resolucion');

        $filename = $model->Archivo;
		$filepath = Yii::app()->params['UploadDir'].DIRECTORY_SEPARATOR.$filename;

        if(file_exists($filepath))
        {
            // Set up PDF headers
            header('Content-type: application/pdf');
            header('Content-Disposition: inline; filename="' . $filename . '"');
            header('Content-Transfer-Encoding: binary');
            header('Content-Length: ' . filesize($filepath));
            header('Accept-Ranges: bytes');

            // Render the file
            readfile($filepath);
        }
        else
        {
            // PDF doesn't exist so throw an error or something
			throw new CHttpException('Archivo no encontrado. ('.$model->Archivo.') <BR><BR>'.
															 '<a href="'.Yii::app()->request->urlReferrer.'">Retornar a la página anterior.</a>'
															);
        }
		
	}

	public function actionGetJuzgados() {
		$IdCircunscripcion = $_GET['IdCircunscripcion'];
		$Promt			 			 = $_GET['Promt'];
		if($IdCircunscripcion == ""){
			echo('<option value="">'.$Promt.'</option>'."\r\n");
		} else {
			$q = 'SELECT IdJuzgado, Nombre FROM juzgado WHERE IdCircunscripcion='.$IdCircunscripcion;
			$cmd = Yii::app()->db->createCommand($q);
			$result = $cmd->query();	
			
			echo('<option value="">'.$Promt.'</option>'."\r\n");
			foreach ($result as $row) {
				echo('<option value="'.$row['IdJuzgado'].'">'.$row['Nombre'].'</option>'."\r\n");
			}
			
			Yii::app()->end();
		}
	}

	public function actionGetDepartamentos() {
		$IdProvincia = $_GET['IdProvincia'];
		$Promt			 = $_GET['Promt'];
		if($IdProvincia == ""){
			echo('<option value="">'.$Promt.'</option>'."\r\n");
		} else {
			$q = 'SELECT IdDepartamento, Departamento FROM departamento WHERE IdProvincia='.$IdProvincia;
			$cmd = Yii::app()->db->createCommand($q);
			$result = $cmd->query();	
			
			echo('<option value="">'.$Promt.'</option>'."\r\n");
			foreach ($result as $row) {
				echo('<option value="'.$row['IdDepartamento'].'">'.$row['Departamento'].'</option>'."\r\n");
			}
			
			Yii::app()->end();
		}
	}
	
	public function actionClusterMap($id) {
		$this->layout = '//layouts/main';
		if( $id == 'null' ) {
			$modelMarker = null;
		} else {
			if( is_numeric($id) ){
				$modelMarker = $this->loadModel($id, 'Resolucion');
				if( is_null($modelMarker->Latitud) || is_null($modelMarker->Longitud) )
					throw new CHttpException(400, 'Solicitud no válida, el registro no posee coordenadas.');
			}
			else
				throw new CHttpException(400, 'Solicitud no válida, id debe ser entero.');
		}
		$model = new Resolucion;
		$this->render('viewClusterMap', array(
			'model' 			=> $model,
			'modelMarker' => $modelMarker,
		));
	}
	
	public function actionHeatMap() {
		$model = new Resolucion;
		$this->render('viewHeatMap', array( 'model' => $model));
	}

	public function actionStats($id) {
		$model = new Resolucion;
		$this->render('viewStats', array(
			'model' 			=> $model,
		));
	}
	
	public function actiongetMarkers() {
		$NRO_MAX_MARKERS = 1000;
		$data= array();
		
		if( Yii::app()->request->isPostRequest ) {
			if( isset($_POST['lat1']) && isset($_POST['lng1']) && isset($_POST['lat2']) && isset($_POST['lng2']) ){
					$lat1		 = $_POST['lat1'];
					$lng1		 = $_POST['lng1'];
					$lat2		 = $_POST['lat2'];
					$lng2		 = $_POST['lng2'];
					$fechaD	 = $_POST['fechaD'];
					$fechaH	 = $_POST['fechaH'];
					$Circuns = $_POST['Circuns'];
					$Juzgado = $_POST['Juzgado'];
					$Tipos	 = $_POST['Tipos'];

					// Change date format dd/mm/yyyy to yyyy-mm-dd
					$fechaD = implode('-', array_reverse(explode('/', $fechaD)));
					$fechaH = implode('-', array_reverse(explode('/', $fechaH)));
					
					// Validate parameters
					$cmd = Yii::app()->db->createCommand();
					$cmd->selectDistinct('resolucion.IdResolucion, resolucion.Codigo, Titulo, Latitud, Longitud');
					$cmd->from('resolucion');
					$cmd->leftJoin('estandardresol', 'resolucion.IdResolucion = estandardresol.IdResolucion');
					$cmd->leftJoin('juzgado', 'resolucion.IdJuzgado = juzgado.IdJuzgado');
					$cmd->leftJoin('circunscripcion', 'juzgado.IdCircunscripcion = circunscripcion.IdCircunscripcion');
					
					$q = "";
					if ( $Tipos == "" ) {
						$Tipos = -1;
					}
					$q .= "estandardresol.IdEstandard IN ( $Tipos ) AND ";
					
					if ( $Circuns != "" ) {
						$q .= "circunscripcion.IdCircunscripcion = $Circuns AND ";
					}
					
					if ( $Juzgado != "" ) {
						$q .= "juzgado.IdJuzgado = $Juzgado AND ";
					}
					
					if ( $fechaD != "" and $fechaH != "" ) {
						$q .= "Fecha BETWEEN '$fechaD' AND '$fechaH' AND ";
					}
				
					if ( $lng1 > $lng2 ) {
						$q .= "Latitud  BETWEEN $lat1 AND $lat2 AND 
												( Longitud <= 180					AND  Longitud >= $lng1 OR 
													Longitud <= $lng2 AND  Longitud >= -180 ) ORDER BY IdResolucion,IdEstandard";
					}else{
						$q .= "Latitud  BETWEEN $lat1	AND $lat2 AND 
											 Longitud BETWEEN $lng1 AND $lng2 ORDER BY IdResolucion,IdEstandard";
					}

					$cmd->where($q);
					//$cmd->order = 'date_published DESC';
					$cmd->limit($NRO_MAX_MARKERS);
//echo $cmd->getText(); exit();
					
					$result = $cmd->query();
					if($result){
						foreach ($result as $row) {
							$data[] = array( $row['IdResolucion'], $row['Codigo'], $row['Titulo'], $row['Latitud'], $row['Longitud']/*, $row['IdEstandard']*/ );
						}
					}
					echo json_encode($data);

			}else
				throw new CHttpException(400,'Cooirdenadas no válidas.');

		}else
				throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	public function actiongetHeatMarkers() {
		$data= array();
		
		if( Yii::app()->request->isPostRequest ) {
			$Markersmodel = Resolucion::model()->findAll( array(
							//'order'=>'name'
					));
			if($Markersmodel){
				foreach( $Markersmodel as $marker ){
					// {lat: 24.6408, lng:46.7728, count: 3},
					$data[] = array( "lat"=>$marker->Latitud, "lng"=>$marker->Longitud, "count"=>1 );
				}
			}
			echo json_encode($data);
		}else
				throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}
	
}