<?php

/**
 * This is the model base class for the table "juzgado".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Juzgado".
 *
 * Columns in table "juzgado" available as properties of the model,
 * followed by relations of table "juzgado" available as properties of the model.
 *
 * @property string $IdJuzgado
 * @property string $IdCircunscripcion
 * @property string $Nombre
 * @property string $Domicilio
 * @property string $Piso
 * @property string $Barrio
 * @property string $Localidad
 * @property string $Telefono
 * @property string $Email
 *
 * @property Circunscripcion $idCircunscripcion
 * @property Resolucion[] $resolucions
 */
abstract class BaseJuzgado extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'juzgado';
	}

	public static function label($n = 1) {
		//return Yii::t('app', 'Juzgado|Juzgados', $n);
		return Yii::t('app', 'Informante|Informantes', $n);
	}

	public static function representingColumn() {
		return 'Nombre';
	}

	public function rules() {
		return array(
			array('IdCircunscripcion, Nombre', 'required'),
			array('IdCircunscripcion', 'length', 'max'=>11),
			array('Nombre, Domicilio', 'length', 'max'=>200),
			array('Piso, Telefono, Email', 'length', 'max'=>45),
			array('Barrio, Localidad', 'length', 'max'=>100),
			array('Domicilio, Piso, Barrio, Localidad, Telefono, Email', 'default', 'setOnEmpty' => true, 'value' => null),
			array('IdJuzgado, IdCircunscripcion, Nombre, Domicilio, Piso, Barrio, Localidad, Telefono, Email', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'idCircunscripcion' => array(self::BELONGS_TO, 'Circunscripcion', 'IdCircunscripcion'),
			'resolucions' => array(self::HAS_MANY, 'Resolucion', 'IdJuzgado'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdJuzgado' => Yii::t('app', 'Id Juzgado'),
			'IdCircunscripcion' => null,
			'Nombre' => Yii::t('app', 'Nombre'),
			'Domicilio' => Yii::t('app', 'Domicilio'),
			'Piso' => Yii::t('app', 'Piso'),
			'Barrio' => Yii::t('app', 'Barrio'),
			'Localidad' => Yii::t('app', 'Localidad'),
			'Telefono' => Yii::t('app', 'Telefono'),
			'Email' => Yii::t('app', 'Email'),
			'idCircunscripcion' => null,
			'resolucions' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdJuzgado', $this->IdJuzgado, true);
		$criteria->compare('IdCircunscripcion', $this->IdCircunscripcion);
		$criteria->compare('Nombre', $this->Nombre, true);
		$criteria->compare('Domicilio', $this->Domicilio, true);
		$criteria->compare('Piso', $this->Piso, true);
		$criteria->compare('Barrio', $this->Barrio, true);
		$criteria->compare('Localidad', $this->Localidad, true);
		$criteria->compare('Telefono', $this->Telefono, true);
		$criteria->compare('Email', $this->Email, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}