<?php

/**
 * This is the model base class for the table "resolucion".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Resolucion".
 *
 * Columns in table "resolucion" available as properties of the model,
 * followed by relations of table "resolucion" available as properties of the model.
 *
 * @property string $IdResolucion
 * @property string $Codigo
 * @property string $Titulo
 * @property string $Sumario
 * @property string $Sintesis
 * @property string $Texto
 * @property string $Fecha
 * @property string $IdCircunscripcion
 * @property string $IdJuzgado
 * @property string $IdCategoria
 * @property string $IdTipo
 * @property string $IdProvincia
 * @property string $IdDepartamento
 * @property string $Localidad
 * @property string $Domicilio
 * @property string $Latitud
 * @property string $Longitud
 * @property string $Archivo
 *
 * @property Estandardresol[] $estandardresols
 * @property Juzgado $idJuzgado
 * @property Categoria $idCategoria
 * @property Tipo $idTipo
 * @property Circunscripcion $idCircunscripcion
 * @property Departamento $idDepartamento
 * @property Provincia $idProvincia
 */
abstract class BaseResolucion extends GxActiveRecord {

	public $ListaEstandares;
	
	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'resolucion';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Resolucion|Resoluciones', $n);
	}

	public static function representingColumn() {
		return 'Titulo';
	}

	public function rules() {
		return array(
			array('Titulo', 'required'),
			array('ListaEstandares', 'required'),
			array('Codigo', 'length', 'max'=>30),
			array('Titulo, Localidad, Domicilio', 'length', 'max'=>300),
			array('IdCircunscripcion, IdCategoria, IdTipo, IdProvincia, IdDepartamento', 'length', 'max'=>10),
			array('IdJuzgado', 'length', 'max'=>11),
			array('Latitud', 'length', 'max'=>10),
			array('Longitud', 'length', 'max'=>11),
			array('Archivo', 'length', 'max'=>200),
			array('Archivo', 'file', 'allowEmpty' => true, 'types' => 'pdf', 'maxSize' => 1024*1024*2, 'safe' => true, 
						'on' => 'insert'),
			array('Archivo', 'file', 'allowEmpty' => true, 'types' => 'pdf', 'maxSize' => 1024*1024*2, 'safe' => false, 
						'except' => 'insert'),

			array('Sumario, Sintesis, Texto, Fecha', 'safe'),
			array('Codigo, Sumario, Sintesis, Texto, Fecha, IdCircunscripcion, IdJuzgado, IdCategoria, IdTipo, IdProvincia, IdDepartamento, Localidad, Domicilio, Latitud, Longitud, Archivo', 'default', 'setOnEmpty' => true, 'value' => null),
			array('IdResolucion, Codigo, Titulo, Sumario, Sintesis, Texto, Fecha, IdCircunscripcion, IdJuzgado, IdCategoria, IdTipo, IdProvincia, IdDepartamento, Localidad, Domicilio, Latitud, Longitud, Archivo, ListaEstandares', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'estandardresols' => array(self::HAS_MANY, 'Estandardresol', 'IdResolucion'),
			'idJuzgado' => array(self::BELONGS_TO, 'Juzgado', 'IdJuzgado'),
			'idCategoria' => array(self::BELONGS_TO, 'Categoria', 'IdCategoria'),
			'idTipo' => array(self::BELONGS_TO, 'Tipo', 'IdTipo'),
			'idCircunscripcion' => array(self::BELONGS_TO, 'Circunscripcion', 'IdCircunscripcion'),
			'idDepartamento' => array(self::BELONGS_TO, 'Departamento', 'IdDepartamento'),
			'idProvincia' => array(self::BELONGS_TO, 'Provincia', 'IdProvincia'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'IdResolucion' => Yii::t('app', 'Id Resolucion'),
			'Codigo' => Yii::t('app', 'Codigo'),
			'Titulo' => Yii::t('app', 'Titulo'),
			'Sumario' => Yii::t('app', 'Sumario'),
			'Sintesis' => Yii::t('app', 'Sintesis'),
			'Texto' => Yii::t('app', 'Texto'),
			'Fecha' => Yii::t('app', 'Fecha'),
			'IdCircunscripcion' => null,
			'IdJuzgado' => null,
			'IdCategoria' => null,
			'IdTipo' => null,
			'IdProvincia' => null,
			'IdDepartamento' => null,
			'Localidad' => Yii::t('app', 'Localidad'),
			'Domicilio' => Yii::t('app', 'Domicilio'),
			'Latitud' => Yii::t('app', 'Latitud'),
			'Longitud' => Yii::t('app', 'Longitud'),
			'Archivo' => Yii::t('app', 'Archivo'),
			'estandardresols' => null,
			'idJuzgado' => null,
			'idCategoria' => null,
			'idTipo' => null,
			'idCircunscripcion' => null,
			'idDepartamento' => null,
			'idProvincia' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('IdResolucion', $this->IdResolucion, true);
		$criteria->compare('Codigo', $this->Codigo, true);
		$criteria->compare('Titulo', $this->Titulo, true);
		$criteria->compare('Sumario', $this->Sumario, true);
		$criteria->compare('Sintesis', $this->Sintesis, true);
		$criteria->compare('Texto', $this->Texto, true);
		$criteria->compare('Fecha', $this->Fecha, true);
		$criteria->compare('IdCircunscripcion', $this->IdCircunscripcion);
		$criteria->compare('IdJuzgado', $this->IdJuzgado);
		$criteria->compare('IdCategoria', $this->IdCategoria);
		$criteria->compare('IdTipo', $this->IdTipo);
		$criteria->compare('IdProvincia', $this->IdProvincia);
		$criteria->compare('IdDepartamento', $this->IdDepartamento);
		$criteria->compare('Localidad', $this->Localidad, true);
		$criteria->compare('Domicilio', $this->Domicilio, true);
		$criteria->compare('Latitud', $this->Latitud, true);
		$criteria->compare('Longitud', $this->Longitud, true);
		$criteria->compare('Archivo', $this->Archivo, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}