<?php

$this->breadcrumbs = array(
	$model->label(2) => array('index'),
	GxHtml::valueEx($model),
);

$this->menu=array(
	array('label'=>Yii::t('app', 'List') . ' ' . $model->label(2), 'url'=>array('index')),
	array('label'=>Yii::t('app', 'Create') . ' ' . $model->label(), 'url'=>array('create')),
	array('label'=>Yii::t('app', 'Update') . ' ' . $model->label(), 'url'=>array('update', 'id' => $model->IdResolucion)),
	array('label'=>Yii::t('app', 'Delete') . ' ' . $model->label(), 'url'=>'#', 'linkOptions' => array('submit' => array('delete', 'id' => $model->IdResolucion), 'confirm'=>'Are you sure you want to delete this item?')),
	array('label'=>Yii::t('app', 'Manage') . ' ' . $model->label(2), 'url'=>array('admin')),
);
?>

<h1><?php echo Yii::t('app', 'View') . ' Mapa de Calor'; ?></h1>

<div id="mapid" style="height: 700px; width: 100%"></div>
<?php 
	//$baseURL = $this->createAbsoluteUrl('resolucion/view', array('id' => 23));
	$baseURL = Yii::app()->request->hostInfo.Yii::app()->request->baseUrl."/";
	$ajaxURL = Yii::app()->createUrl('resolucion/GetHeatMarkers');

	echo CHtml::script("
      window.onload = function() {

				$.ajax({ 
					async: false,
					type: 'POST', 
					url: '".$ajaxURL."',
					//data: { 'lat1':-90.0, 'lng1':-180.0, 'lat2':90.0, 'lng2':180.0 },
					success: function(data){
									arrMarkers = JSON.parse(data); 
					},
					error: function(err){   
									alert('failure '+err); 
					} 
				});				
				
        var testData = {
          max: 1,
          data: arrMarkers,
        };

        var baseLayer = L.tileLayer(
          'http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',{
            attribution: 'Map data &copy',
            maxZoom: 18
          }
        );

        var cfg = {
          // radius should be small ONLY if scaleRadius is true (or small radius is intended)
          'radius': 0.0011,
          'maxOpacity': .4, 
          // scales the radius based on map zoom
          'scaleRadius': true, 
          // if set to false the heatmap uses the global maximum for colorization
          // if activated: uses the data maximum within the current map boundaries 
          //   (there will always be a red spot with useLocalExtremas true)
          'useLocalExtrema': true,
          // which field name in your data represents the latitude - default lat
          latField: 'lat',
          // which field name in your data represents the longitude - default lng
          lngField: 'lng',
          // which field name in your data represents the data value - default value
          valueField: 'count'
        };


        var heatmapLayer = new HeatmapOverlay(cfg);

        var map = new L.Map('mapid', {
          attributionControl: false,
					fullscreenControl: true, 
					center: new L.LatLng(-28.47, -65.78),
          zoom: 13,
          layers: [baseLayer, heatmapLayer]
        });

        heatmapLayer.setData(testData);

        // make accessible for debugging
        layer = heatmapLayer;
      };	"); 
?>

<?php 
	Yii::app()->clientScript->registerCssFile( 'https://unpkg.com/leaflet@1.3.1/dist/leaflet.css' );
	Yii::app()->clientScript->registerScriptFile( 'https://unpkg.com/leaflet@1.3.1/dist/leaflet.js' );
	
	// Plugin - FullScreen
	$assetUrl = Yii::app()->getAssetManager()->publish(Yii::getPathOfAlias('ext.leafletfullscreenmaster'));
	Yii::app()->clientScript->registerCssFile($assetUrl.'/Control.FullScreen.css'); 
	Yii::app()->clientScript->registerScriptFile($assetUrl.'/Control.FullScreen.js'); 
	
	// Plugin - HeatMap
	$assetUrl = Yii::app()->getAssetManager()->publish(Yii::getPathOfAlias('ext.leafletheatmap'));
	Yii::app()->clientScript->registerScriptFile($assetUrl.'/heatmap.min.js'); 
	Yii::app()->clientScript->registerScriptFile($assetUrl.'/leaflet-heatmap.js'); 

?>

