<?php
class AuditoriaBehavior extends CActiveRecordBehavior
{
    private $_oldattributes = array();

    private function getModelKey( $Owner )
    {
				switch ( get_class($Owner) ) {
						case 'Categoria':
								$key = $Owner->Categoria;
								break;
						case 'Circunscripcion':
								$key = $Owner->Nombre;
								break;
						case 'Estandard':
								$key = $Owner->Estandar;
//Yii::log(get_class($Owner), 'warning', 'application');
								break;
						case 'Juzgado':
								$key = $Owner->Nombre;
								break;
						case 'Resolucion':
								$key = $Owner->Codigo;
								break;
						case 'Subestandard':
								$key = $Owner->Subestandard;
								break;
						case 'Tipo':
								$key = $Owner->Tipo;
								break;
						default:
								//ERROR
								$key = 'Error getModelKey: Modelo desconocido.';
				}
				return( $key );
		}
 
    public function afterSave($event)
    {
				$key = $this->getModelKey( $this->Owner );
//Yii::log( '$key='.$key, 'warning', 'application');
				if (!$this->Owner->isNewRecord) {
 
            // new attributes
            $newattributes = $this->Owner->getAttributes();
            $oldattributes = $this->getOldAttributes();
 
            // compare old and new
            foreach ($newattributes as $name => $value) {
                if (!empty($oldattributes)) {
                    $old = $oldattributes[$name];
                } else {
                    $old = '';
                }
 
                if ($value != $old) {
                    //$changes = $name . ' ('.$old.') => ('.$value.'), ';
 
                    $log = new Auditoria;
										$log->Fecha   = new CDbExpression('NOW()');
										$log->Usuario = Yii::app()->user->Name;
										$log->Accion  = 'modificó';
										$log->Tabla   = get_class($this->Owner);
										$log->Clave   = $key;
										$log->Campo   = $name;
                    $resultado    = $log->save();
//Yii::log( "get_class($this->Owner)=".get_class($this->Owner)." /  SAVE=".$resultado, 'warning', 'application');
//Yii::log( "this->Owner=".$this->Owner, 'warning', 'application');
                }
            }
        } else {
            $log=new Auditoria;
						$log->Fecha   = new CDbExpression('NOW()');
						$log->Usuario = Yii::app()->user->Name;
						$log->Accion  = 'creó';
						$log->Tabla   = get_class($this->Owner);
						$log->Clave   = $key;
						$log->Campo   = '';
						$log->save();
        }
    }
 
    public function afterDelete($event)
    {
				$Attributes = $this->getOldAttributes();
				
				$key = $this->getModelKey( $this->Owner );				
				
        $log=new Auditoria;
				$log->Fecha   = new CDbExpression('NOW()');
				$log->Usuario = Yii::app()->user->Name;
				$log->Accion  = 'eliminó';
				$log->Tabla   = get_class($this->Owner);
				$log->Clave   = $key;
				$log->Campo   = '';
				$log->save();
    }
 
    public function afterFind($event)
    {
        // Save old values
        $this->setOldAttributes($this->Owner->getAttributes());
    }
 
    public function getOldAttributes()
    {
        return $this->_oldattributes;
    }
 
    public function setOldAttributes($value)
    {
        $this->_oldattributes=$value;
    }
}
?>
