<?php

class CircunscripcionController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			);
}

public function accessRules() {
	return array(
			array('allow', 
				'actions'=>array('index', 'view', 'admin'),
				'users'=>array('@'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create', 'update', 'delete'),
				'users'=>array('informatica', 'M.Whitaker', 'A.Miranda'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'Circunscripcion'),
		));
	}

	public function actionCreate() {
		$model = new Circunscripcion;


		if (isset($_POST['Circunscripcion'])) {
			$model->setAttributes($_POST['Circunscripcion']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->IdCircunscripcion));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'Circunscripcion');


		if (isset($_POST['Circunscripcion'])) {
			$model->setAttributes($_POST['Circunscripcion']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->IdCircunscripcion));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	/*public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'Circunscripcion')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}*/

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {

			try{
					$this->loadModel($id, 'Circunscripcion')->delete();
					/*if(!isset($_GET['ajax']))
							// Normal (without ajax)
							Yii::app()->user->setFlash('success','Normal - Juzgado eliminado con éxito.');
					else
							//for ajax
							echo "<div class='text-success'>Ajax - Juzgado eliminado con éxito.</div>";*/
			}catch(CDbException $e){
					$cod_err = $e->errorInfo[1];
					if($cod_err == Yii::app()->params['err_integridad_referencial']) {
						$circunscripcion = $this->loadModel($id, 'Circunscripcion')->Nombre;
						if(!isset($_GET['ajax']))
								// Normal (without ajax)
								Yii::app()->user->setFlash('error','No se puede eliminar ('.$circunscripcion.') porque tiene registros asociados.');
						else
								//for ajax
								echo "<div class='alert alert-error'>
												<button type='button' class='close' data-dismiss='alert'>×</button>
												No se puede eliminar (".$circunscripcion.") porque tiene registros asociados.
											</div>";
					} else {
						if(!isset($_GET['ajax']))
								// Normal (without ajax)
								Yii::app()->user->setFlash('error','Codigo error: '.$cod_err.'<BR>Mensaje de error: '.$e->getMessage());
						else
								//for ajax
								echo "<div class='alert alert-error'>
												<button type='button' class='close' data-dismiss='alert'>×</button>
												<strong>Codigo error: ".$cod_err."</strong> ".$e->getMessage()."
											</div>";

					}
			}
 
			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
					$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));

		} else
				throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Circunscripcion');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Circunscripcion('search');
		$model->unsetAttributes();

		if (isset($_GET['Circunscripcion']))
			$model->setAttributes($_GET['Circunscripcion']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

}