<?php

class ReciboController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			'userCheck',
			);
}

public function accessRules() {
	return array(
			array('allow', 
				'actions'=>array('admin', 'download'),
				'users'=>array('@'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create', 'index', 'view', 'update', 'delete'),
				'users'=>array('admin'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'Recibo'),
		));
	}

	public function actionCreate() {
		$model = new Recibo;


		if (isset($_POST['Recibo'])) {
			$model->setAttributes($_POST['Recibo']);

			if ($model->save()) {
				if (Yii::app()->getRequest()->getIsAjaxRequest())
					Yii::app()->end();
				else
					$this->redirect(array('view', 'id' => $model->idrecibo));
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'Recibo');


		if (isset($_POST['Recibo'])) {
			$model->setAttributes($_POST['Recibo']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->idrecibo));
			}
		}

		$this->render('update', array(
				'model' => $model,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'Recibo')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('Recibo');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new Recibo('search');
		$model->unsetAttributes();

		$modelUser = User::model()->findByPk( Yii::app()->user->getId() );;

		if (isset($_GET['Recibo']))
			$model->setAttributes($_GET['Recibo']);

		$this->render('admin', array(
			'model' => $model,
			'modelUser' => $modelUser,
		));
	}

	public function actionDownload($id)
	{	        
		$model = $this->loadModel($id, 'Recibo');
		/*$path =  Yii::getPathOfAlias('application.uploads').DIRECTORY_SEPARATOR.
																 $model->idruta0->ruta.DIRECTORY_SEPARATOR.$model->archivo;*/

		$path =  'D:\webapps\recibos\uploads'.DIRECTORY_SEPARATOR.
						 $model->idruta0->ruta.DIRECTORY_SEPARATOR.$model->archivo;
//Yii::log( '* * * RUTA = '.$path, 'warning', 'application');
		if (file_exists($path)) {

			$log = new Auditoria;
			$log->Fecha   = new CDbExpression('NOW()');
			$log->Usuario = Yii::app()->user->Name;
			$log->Accion  = 'descargó';
			$log->Tabla   = 'Recibo';
			$log->Clave   = $model->archivo;
			$log->Campo   = '';
			$log->save();
			
			Yii::app()->getRequest()->sendFile(basename($path), @file_get_contents($path));

		} else {
			throw new CHttpException('Archivo de recibo no encontrado. ('.$model->archivo.') <BR><BR>'.
															 '<a onclick="window.close();" href="#">Cerrar página.</a>'
															 //'<a href="'.Yii::app()->request->urlReferrer.'">Retornar a la página anterior.</a>'
															);
		}		
	}

	public function filteruserCheck($fc) {
		$UserId = Yii::app()->user->getId();
		$User = $this->loadModel( $UserId, 'User' );

		if ( $User->deshabilitada ) {
			// No permitir acceso a cuentas deshabilitadas.
			throw new CHttpException('Su cuenta está deshabilitada. Para mayor información, contáctese con Secretaría Contable.<BR><BR>'
															 //.'<a onclick="window.close();" href="#">Cerrar página.</a>'
															);
		}
		
		if ( $User->cambiar_psw ) {
			// Forzar cambio contraseña
			$this->redirect(array('user/update', 'id'=>$UserId));
		} else {
			$fc->run();
		}
	}

}