<?php

class UserController extends GxController {

public function filters() {
	return array(
			'accessControl', 
			//'userCheck',
			);
}

public function accessRules() {
	return array(
			array('allow', 
				'actions'=>array('view', 'update'),
				'users'=>array('@'),
				),
			array('allow', 
				'actions'=>array('minicreate', 'create', 'delete', 'index', 'admin'),
				'users'=>array('admin'),
				),
			array('deny', 
				'users'=>array('*'),
				),
			);
}

	public function actionView($id) {
		$this->render('view', array(
			'model' => $this->loadModel($id, 'User'),
		));
	}

	public function actionCreate() {
		$model = new User;


		if (isset($_POST['User'])) {
			$model->setAttributes($_POST['User']);
			$model->password = $model->hashPassword($_POST['User']['password'], $_POST['User']['username']);
			$model->passwordCompare = $model->hashPassword($_POST['User']['passwordCompare'], $_POST['User']['username']);

			if($model->save())
					$this->redirect(array('view','id'=>$model->iduser));
			else {
					$model->password = $_POST['User']['password'];
					$model->passwordCompare = $_POST['User']['passwordCompare'];
			}
		}

		$this->render('create', array( 'model' => $model));
	}

	public function actionUpdate($id) {
		$model = $this->loadModel($id, 'User');
		if ( $model->deshabilitada ) {
			// No permitir acceso a cuentas deshabilitadas.
			throw new CHttpException('Su cuenta está deshabilitada. Para mayor información, contáctese con Secretaría Contable.<BR><BR>'
															 //.'<a onclick="window.close();" href="#">Cerrar página.</a>'
															);
		}
		
		$model->password = "";
		$ForzarCambioPws = $model->cambiar_psw;
		$model->cambiar_psw = 0;

		if (isset($_POST['User'])) {
			$model->setAttributes($_POST['User']);

			if ($model->save()) {
				$this->redirect(array('view', 'id' => $model->iduser));

			} else {
				$model->password 				= "";
				$model->passwordCompare = "";
				$model->cambiar_psw = 1;
			}
		}

		$this->render('update', array(
				'model' => $model,
				'ForzarCambioPws' => $ForzarCambioPws,
				));
	}

	public function actionDelete($id) {
		if (Yii::app()->getRequest()->getIsPostRequest()) {
			$this->loadModel($id, 'User')->delete();

			if (!Yii::app()->getRequest()->getIsAjaxRequest())
				$this->redirect(array('admin'));
		} else
			throw new CHttpException(400, Yii::t('app', 'Your request is invalid.'));
	}

	public function actionIndex() {
		$dataProvider = new CActiveDataProvider('User');
		$this->render('index', array(
			'dataProvider' => $dataProvider,
		));
	}

	public function actionAdmin() {
		$model = new User('search');
		$model->unsetAttributes();

		if (isset($_GET['User']))
			$model->setAttributes($_GET['User']);

		$this->render('admin', array(
			'model' => $model,
		));
	}

	public function filteruserCheck($fc) {
		$UserId = Yii::app()->user->getId();
		$User = $this->loadModel( $UserId, 'User' );

		/*if ( $User->deshabilitada ) {
			// No permitir acceso a cuentas deshabilitadas.
			throw new CHttpException('Su cuenta está deshabilitada. Para mayor información, contáctese con Secretaría Contable.<BR><BR>'
															 //.'<a onclick="window.close();" href="#">Cerrar página.</a>'
															);
		}*/
		
		if ( $User->cambiar_psw ) {
			// Forzar cambio contraseña
			$this->redirect(array('user/update', 'id'=>$UserId));
		} else {
			$fc->run();
		}
	}

}