<?php

/**
 * This is the model base class for the table "recibo".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "Recibo".
 *
 * Columns in table "recibo" available as properties of the model,
 * followed by relations of table "recibo" available as properties of the model.
 *
 * @property string $idrecibo
 * @property string $iduser
 * @property string $mes
 * @property integer $anio
 * @property string $idruta
 * @property string $archivo
 *
 * @property Ruta $idruta0
 * @property User $iduser0
 */
abstract class BaseRecibo extends GxActiveRecord {

	public static function model($className=__CLASS__) {
		return parent::model($className);
	}

	public function tableName() {
		return 'recibo';
	}

	public static function label($n = 1) {
		return Yii::t('app', 'Recibo|Recibos', $n);
	}

	public static function representingColumn() {
		return 'mes';
	}

	public function rules() {
		return array(
			array('iduser, mes, anio, idruta, archivo', 'required'),
			array('anio', 'numerical', 'integerOnly'=>true),
			array('iduser, mes, idruta', 'length', 'max'=>10),
			array('archivo', 'length', 'max'=>256),
			array('idrecibo, iduser, mes, anio, idruta, archivo', 'safe', 'on'=>'search'),
		);
	}

	public function relations() {
		return array(
			'idruta0' => array(self::BELONGS_TO, 'Ruta', 'idruta'),
			'iduser0' => array(self::BELONGS_TO, 'User', 'iduser'),
		);
	}

	public function pivotModels() {
		return array(
		);
	}

	public function attributeLabels() {
		return array(
			'idrecibo' => Yii::t('app', 'Idrecibo'),
			'iduser' => null,
			'mes' => Yii::t('app', 'Mes'),
			'anio' => Yii::t('app', 'Año'),
			'idruta' => null,
			'archivo' => Yii::t('app', 'Recibo'),
			'idruta0' => null,
			'iduser0' => null,
		);
	}

	public function search() {
		$criteria = new CDbCriteria;

		$criteria->compare('idrecibo', $this->idrecibo, true);
		$criteria->compare('iduser', $this->iduser);
		$criteria->compare('mes', $this->mes, true);
		$criteria->compare('anio', $this->anio);
		$criteria->compare('idruta', $this->idruta);
		$criteria->compare('archivo', $this->archivo, true);

		return new CActiveDataProvider($this, array(
			'criteria' => $criteria,
		));
	}
}